<?php
/****************************************************************************\|
| Gchats Visichat		                                               		  |
| Copyright (c) 2007-2012 Gchats http://www.gchats.com      		  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT"  |
| FILE PROVIDED WITH THIS DISTRIBUTION.                                       |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| GCHATS Visichat 2.0 PROGRAM WITH  THIS  AGREEMENT.                          |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Gchat Design Studio           |
\*****************************************************************************/
include("common.php");
include("checker.php");

$config 		= $factory->getInstance("config");
$visichat 		= $factory->getInstance("visichat");
$music_dir 		= "../music";
$allowed_ext 	= array("mp3" , "flv"); // allowed extensions in the playlist
$playlist		= array();

$options = array(
				 array("Previous Button","show_Back","yes"),
				 array("Next Button","show_Next","yes"),
				 array("Stop Button","show_Stop","yes"),
				 array("Display timer","show_timer","yes"),
				 array("Display equalizer","show_equalizer","no"),
				 array("Display volume","show_Volume","yes"),
				 array("Display pan","show_pan","no"),
				 array("Display titlebar","show_titlebar","yes")
			);

$styles = array(
				array("Control bar Background","controllbar_background"),
				array("Control bar Border","controllbar_border"),
				array("Volume/Pan/Slider background","controllbar_background_value"),
				array("Control bar Text color","controllbar_text"),
				array("Preloader color","controllbar_load"),
				array("Control bar inner border color","controllbar_inner_border"),
				array("Title bar background","titlebar_background"),
				array("Title bar text color","titlebar_text"),
				array("Title bar icon color","titlebar_icon"),
				array("Display background","display_background"),
				array("Display border color","display_border"),
				array("Scroll bar background","scrollbar_bg"),
				array("Scroll bar color","scroll_color"),
				array("Playlist track background","playlist_track_background"),
				array("Playlist selected track","playlist_track_selected"),
				array("Playlist track time color","playlist_track_time"),
				array("Playlist track text color","playlist_track_text"),
				array("Playlist track icon color","playlist_icon")
			);

if($_GET["ac"]=="u" && $_POST["savesetting"]=="yes"){
	
	if($_SESSION["visichat_access"]=="1"){
		$valid = true;
		
		if(post("playlist") != ""){
			if(substr(post("playlist"),0,7) != "http://"){
				$result = "play list URL should be a valid URL starting with http://";	
				$valid = false;
			}else{
				if($visichat->getRemoteFileSize(post("playlist")) == 0 || $visichat->getRemoteFileSize(post("playlist")) >1000000 ){
					$result = "Playlist file cannot be found, please check the link";
					$valid = false;
				}
			}
		}
		
		if($valid){
			for($i=0;$i<count($options);$i++){
				if(post($options[$i][1])=="yes"){
					$value = "yes";
				}else{
					$value = "no";
				}
				
				$setting->set("mediaplayer_".$options[$i][1],$value);
			}
			for($i=0;$i<count($styles);$i++){
				$setting->set("mediaplayer_".$styles[$i][1],post($styles[$i][1]));
			}
			if(post("enable_media") == "yes"){
				$setting->set("mediaplayer_enable","yes");
			}else{
				$setting->set("mediaplayer_enable","no");
			}
			$setting->set("mediaplayer_playlist_url",post("playlist"));
			
			if(is_numeric(post("titlebar_alpha")) && post("titlebar_alpha") >= 0 && post("titlebar_alpha")<100){
				$setting->set("mediaplayer_titlebar_alpha",post("titlebar_alpha"));
			}
			
			if(is_numeric(post("titlebar_delay_seconds")) && post("titlebar_delay_seconds") >= 0 && post("titlebar_delay_seconds")<10){
				$setting->set("mediaplayer_titlebar_delay_seconds",post("titlebar_delay_seconds"));
			}
			
			if(is_numeric(post("playlist_track_height")) && post("playlist_track_height") > 10 && post("playlist_track_height")<=100){
				$setting->set("mediaplayer_playlist_track_height",post("playlist_track_height"));
			}
			if(is_numeric(post("media_player_width")) && post("media_player_width") > 100){
				$setting->set("media_player_width",post("media_player_width"));	
			}
			if(is_numeric(post("media_player_height")) && post("media_player_width") > 50){
				$setting->set("media_player_height",post("media_player_height"));	
			}
			$setting->save();
			$result = "Data updated successfully.";
		}
	}else{
		$result = "You don't have access to this function";
	}	
}



// Upload a new file to the playlist
if ( get("ac") == "upload" )
{
	if($_SESSION["visichat_access"]=="1")
	{
	
		// Check if the file uploaded
		if( ! isset($_FILES["media"]) )
		{
			$result = "Media file is required.";	
		}
		else
		{
			if( $_FILES["media"]["name"] == "" )
			{
				$result = "Media file is required.";	
			}
			else
			{
				$path_info 	= pathinfo( $_FILES["media"]["name"] );
	
				$filename = preg_replace ( "/[\.\<\>\|\?\*\/\\\]/", "" , $path_info["filename"] );
				$extension = $path_info["extension"];
				
				if( !in_array( strtolower( $extension ) , $allowed_ext ) )
				{
					$result = "Media file is not a valid format.";	
				}
				else
				{
					if( move_uploaded_file($_FILES["media"]['tmp_name'], $music_dir.DS.$filename.".".$extension ))
					{
						$result = "File uploaded successfully.";		
					}
					else
					{
						$result = "Error in uploading the file, check if the music folder has write permission on it.";		
					}
				}
			}
		}
	}else{
		$result = "You don't have access to this function";
	}	
}

// Load the play list
if (is_dir($music_dir)) 
{
  // read music folder contents
  if ($dh = opendir($music_dir)) 
  {
	while (($file = readdir($dh)) !== false) 
	{
	  // file path
	  $file_path = $music_dir .DS. $file;
	
	  if (filetype($file_path) == "file")
	  {
		
		$file_info = pathinfo($file_path);
		if( in_array($file_info["extension"], $allowed_ext))
		{
			$playlist[] = $file;
		}
	  }
	}
  }
}

// Delete a file from the play list
if ( get("ac") == "d" && get("file") != "" )
{
	if($_SESSION["visichat_access"]=="1")
	{
		
		$info = pathinfo (get("file"));
			
		if ( in_array ( get("file") , $playlist ) && in_array ( $info["extension"] , $allowed_ext ) )
		{
			for ( $i = 0; $i < count ( $playlist ); $i++ )
			{
				if ( $playlist[$i] == get("file") )
				{
					unlink ( $music_dir.DS.get("file") );
					unset ( $playlist[$i] );
				
				}
			}
			
			$playlist = array_values ( $playlist );
			
			$result = get("file")." removed successfully";
		}
		else
		{
			$result = "File not found.";
		}
	}else{
		$result = "You don't have access to this function";
	}	
}

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Gchats Visichat Admin Menu: Media Player</title>
<link href="../images/style.css" rel="stylesheet" type="text/css" />
<script language="javascript" src="../scripts/picker.js"></script>
<script language="javascript">
function check_confirm()
{
	var res = confirm("Are you sure?");
	return res;
}
</script>
<link href="../images/picker.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="Layer1" align="center" style="position:absolute;left:5;top:5;width:90;height:90;z-index:1;"><a href="menu.php"><img src="../images/return.jpg" width="54" height="54" border="0"><br>
  </a><a href="menu.php" class="YellowText">Return...</a></div>
<br />
<br />
<br>
<br>
<div id="Layer2" align="center" class="whileText"><?php echo $result;?></div>
<br>
<table width="800" border="0" align="center" cellpadding="0" cellspacing="0" class="TMain">
  <tr>
    <td width="2" height="18"><img src="../images/r1.gif" width="2" height="18" /></td>
    <td width="300" align="left" background="../images/r2.gif"><strong>&nbsp;&nbsp; Media Player Administration </strong></td>
    <td width="7"><img src="../images/r3.gif" /></td>
    <td background="../images/r4.gif">&nbsp;</td>
    <td width="2"><img src="../images/r5.gif" /></td>
  </tr>
</table>
<table width="800" border="0" align="center" cellpadding="5" cellspacing="0">
  <tr>
    <td width="2" background="../images/r6.gif"></td>
    <td  align="left" valign="top" background="../images/bgdot.gif" class="TextBlack12"><form action="media.php?ac=u" method="post" name="form1">
        <table width="550" border="0" align="center" class="TextBlack12">
          <tr>
            <td colspan="2" align="center" bgcolor="#284172" class="whileText"><strong>Options: </strong></td>
          </tr>
          <tr>
            <td align="right" bgcolor="#FFFFFF" width="60%">Enable / Disable Media Player: </td>
            <td bgcolor="#FFFFFF"><input name="enable_media" type="checkbox" id="enable_media" value="yes" <?php if($setting->get("mediaplayer_enable")=="yes"){?>checked="checked"<?php }?>></td>
          </tr>
          <tr>
            <td align="right" bgcolor="#FFFFFF" >Playlist URL (Should be xspf play list format) <br />
              Leave blank to use uploaded files for playlist: </td>
            <td bgcolor="#FFFFFF"><input type="text" name="playlist" id="playlist" value="<?php echo $setting->get("mediaplayer_playlist_url");?>"></td>
          </tr>
          <?php for($i=0;$i<count($options);$i++){?>
          <tr>
            <td align="right" bgcolor="#FFFFFF" ><?php echo $options[$i][0];?></td>
            <td bgcolor="#FFFFFF"><input type="checkbox" name="<?php echo $options[$i][1];?>" id="<?php echo $options[$i][1];?>" <?php if(($setting->get("mediaplayer_".$options[$i][1])=="yes") || ($setting->get("mediaplayer_".$options[$i][1])=="" && $options[$i][2]=="yes")){?> checked="checked" <?php }?>  value="yes"></td>
          </tr>
          <?php }?>
          <tr>
            <td align="right" bgcolor="#FFFFFF" >Title bar transparency (0-100)</td>
            <td bgcolor="#FFFFFF"><input name="titlebar_alpha" type="text" id="titlebar_alpha" value="<?php if($setting->get("mediaplayer_titlebar_alpha")==""){?>95<?php }else{?><?php echo $setting->get("mediaplayer_titlebar_alpha");?><?php }?>" size="3" maxlength="3"></td>
          </tr>
          <tr>
            <td align="right" bgcolor="#FFFFFF" >Title bar appearance delay seconds (1-9)</td>
            <td bgcolor="#FFFFFF"><input name="titlebar_delay_seconds" type="text" id="titlebar_delay_seconds" value="<?php if($setting->get("mediaplayer_titlebar_delay_seconds")==""){?>1<?php }else{?><?php echo $setting->get("mediaplayer_titlebar_delay_seconds");?><?php }?>" size="3" maxlength="1"></td>
          </tr>
          <tr>
            <td align="right" bgcolor="#FFFFFF" >Playlist track height (10-99)</td>
            <td bgcolor="#FFFFFF"><input name="playlist_track_height" type="text" id="playlist_track_height" value="<?php if($setting->get("mediaplayer_playlist_track_height")==""){?>30<?php }else{?><?php echo $setting->get("mediaplayer_playlist_track_height");?><?php }?>" size="3" maxlength="2"></td>
          </tr>
          <tr>
            <td align="right" bgcolor="#FFFFFF" >Media player width</td>
            <td bgcolor="#FFFFFF"><input name="media_player_width" type="text" id="media_player_width" value="<?php if($setting->get("media_player_width")==""){?>400<?php }else{?><?php echo $setting->get("media_player_width");?><?php }?>" size="3" maxlength="3"></td>
          </tr>
          <tr>
            <td align="right" bgcolor="#FFFFFF" >Media player height</td>
            <td bgcolor="#FFFFFF"><input name="media_player_height" type="text" id="media_player_height" value="<?php if($setting->get("media_player_height")==""){?>300<?php }else{?><?php echo $setting->get("media_player_height");?><?php }?>" size="3" maxlength="3"></td>
          </tr>
          <tr>
            <td colspan="2" align="center" bgcolor="#284172" class="whileText"><strong>Styles: </strong></td>
          </tr>
          <?php for($i=0;$i<count($styles);$i++){?>
          <tr>
            <td align="right" bgcolor="#FFFFFF" ><?php echo $styles[$i][0];?></td>
            <td bgcolor="#FFFFFF"><input name="<?php echo $styles[$i][1];?>" type="text" id="<?php echo $styles[$i][1];?>" size="7" maxlength="7" style="background-color:<?php echo $setting->get("mediaplayer_".$styles[$i][1]);?>" value="<?php echo $setting->get("mediaplayer_".$styles[$i][1]);?>">
              <span onClick="openPicker('<?php echo $styles[$i][1];?>')" class="picker_layer" style="cursor:crosshair;">Pick Color</span></td>
          </tr>
          <?php }?>
          <tr>
            <td colspan="2" align="center" bgcolor="#FFFFFF"><input type="hidden" name="savesetting" value="yes">
              <input type="submit" name="Submit" value="Save Changes"></td>
          </tr>
        </table>
      </form>
      <br>
      <form action="media.php?ac=upload" enctype="multipart/form-data" method="post" name="form2">
      <table width="550" border="0" align="center" class="TextBlack12">
        <tr>
          <td colspan="2" align="center" bgcolor="#284172" class="whileText">Add a new File to play list</td>
        </tr>
        <tr>
          <td align="right" bgcolor="#FFFFFF">Music file :<br>
            <font class="Comments"><font color="#666666"> (.mp3 and .flv files only)</font></font></td>
          <td bgcolor="#FFFFFF"><input type="file" id="media" name="media"></td>
        </tr>
        <tr>
          <td colspan="2" align="center" bgcolor="#FFFFFF"><input type="submit" name="Submit" value="Upload"></td>
        </tr>
      </table>
      </form>
      <br>
      <table width="550" border="0" align="center" cellpadding="2" class="TextBlack12">
      <tr>
          <td colspan="3" align="center" bgcolor="#284172" class="whileText"><strong>Play List</strong></td>
        </tr>
        <tr class="whileText">
          <td align="center" bgcolor="#284172">#</td>
          <td bgcolor="#284172">Filename </td>
          <td align="center" bgcolor="#284172">Delete</td>
        </tr>
        <?php
		    for ( $i = 0; $i < count ($playlist); $i++)
			{
		?>
        <tr>
          <td bgcolor="#FFFFFF" align="center"><?php echo $i+1;?></td>
          <td bgcolor="#FFFFFF" align="left"><?php echo htmlspecialchars( $playlist[$i] );?></td>
          <td bgcolor="#FFFFFF" align="center"><a href="media.php?ac=d&file=<?php echo $playlist[$i];?>" onClick="return check_confirm();" class="Links4">Delete</a></td>
        </tr>
        <?php
		    }
		?>
      </table>
      <br>
      Note: Playlist file should be  xpsf file, you can search in google to find this files, to search enter &quot;filetype:xpsf&quot; in the google search text box and click on the search button. <br>
      Leave the play list file blank and upload your own mp3 musics and flv video files.<br>      
      <br></td>
    <td width="2" background="../images/r7.gif"></td>
  </tr>
</table>
<table width="800"  height="2" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="2" height="2"><img src="../images/r8.gif" width="2" height="2" /></td>
    <td style="background-image:url(../images/r9.gif); font-size:1px;">&nbsp;</td>
    <td height="2" width="2"><img src="../images/r10.gif" /></td>
  </tr>
</table>
</body>
</html>