<?php 
/****************************************************************************\|
| Gchats Visichat		                                               		  |
| Copyright (c) 2007-2012 Gchats http://www.gchats.com      		  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT"  |
| FILE PROVIDED WITH THIS DISTRIBUTION.                                       |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| GCHATS Visichat 2.0 PROGRAM WITH  THIS  AGREEMENT.                          |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Gchat Design Studio           |
\*****************************************************************************/
include("common.php");
include("checker.php");


$chat_styles = array(
	array("styles_show_textchat","Show text chat","checkbox","If you uncheck, it will hide the text chat part from centre and moves the userlist to left side"),
	array("styles_show_webcam","Show my webcam area","checkbox","If you uncheck, My Webcam will be removed and room list size will be adjusted instead."),
	array("styles_bg_picture","Chat background image URL","text"),
	array("styles_login_picture","Chat login logo image URL","text"),
	array("styles_showlog_link","Showlog.php page link URL","text","If users click anywhere in the showlog.php page, they will be redirected to this address"),
	array("styles_login_text","Chat login text (HTML)","textarea"),	
	array("styles_connecting_bg","Chat login, connecting background color","color"),
	array("styles_connecting_border","Chat login, connecting border color","color"),	
	array("styles_connecting_text","Chat login, connecting text color","color"),	
	array("styles_news_text","Chat news (HTML)","textarea"),		
	array("styles_news_bg_color","Chat news background color","color"),	
	array("styles_news_border_color","Chat news border color","color"),		
	array("styles_news_txt_color","Chat news text color","color"),		
	array("styles_news_reload","Rotate chat news every x seconds (0 to disable)","int"),
	array("styles_alpha","Chat transparency (0/100)","int"),
	array("styles_banner_height","Banner place height (pixel)","int"),	
	array("styles_font_size","Default font size (10,12,14,16,18)","int"),
	array("styles_max_smileys","Max smileys per message (0 for unlimited","int"),
	array("styles_bg_color","Chat background color","color"),
	array("styles_text_color","Chat text color","color"),	
	array("styles_userlist_bg","Userlist Background color","color"),
	array("styles_userlist_item_bg","Userlist item background color","color"),	
	array("styles_userlist_item_alt_bg","Userlist alternative item background color","color"),	
	array("styles_userlist_rollOver","Userlist item roll over color","color"),
	array("styles_userlist_text","Userlist text color","color"),
	array("styles_memberlist_bg","Memberlist background color","color"),
	array("styles_memberlist_item_bg","Memberlist item background color","color"),	
	array("styles_memberlist_item_alt_bg","Memberlist alternative item background color","color"),	
	array("styles_memberlist_rollOver","Memberlist item roll over color","color"),
	array("styles_memberlist_text","Memberlist text color","color"),
	array("styles_avatars_bg","Avatarlist background color","color"),
	array("styles_avatars_border_bg","Avatar border background color","color"),	
	array("styles_history_bg","Public history, background color","color"),
	array("styles_mywebcam_bg","My Webcam background color","color"),
	array("styles_mywebcam_black_bg","My Webcam video background color","color"),	
	array("styles_mywebcam_black_border","My Webcam video border color","color"),		
	array("styles_webcam_title_txt_color","My webcam title text color","color"),
	array("styles_webcam_body_txt_color","My webcam body text color","color"),	
	array("styles_gallery_list_bgcolor","Video gallery, list background color","color"),
	array("styles_gallery_movie_bgcolor","Video gallery, video background color","color"),	
	array("styles_gallery_rollOver","Video gallery, item roll over color","color"),
	array("styles_gallery_selected","Video gallery, selected movie background color","color"),
	array("styles_gallery_text","Video gallery, text color","color"),
	array("styles_gallery_timer_text","Video gallery,timer text color","color"),
	array("styles_gallery_timer_bg","Video gallery,timer background color","color"),
	array("styles_roomlist_bg","Roomlist window background color","color"),
	array("styles_rooms_bg","Roomlist Background color","color"),
	array("styles_rooms_alt_bg","Roomlist Alternative Background color","color"),
	array("styles_rooms_selectionColor","Roomlist selection color","color"),
	array("styles_rooms_rollOver","Roomlist roll over color","color"),
	array("styles_rooms_text","Roomlist text color","color"),
	array("styles_publicmessage_bg","Public message typing background color","color"),
	array("styles_publicmessage_text_bg","Public messages textbox background color","color"),
	array("styles_error_bg","Error messages background color","color"),	
	array("styles_userinfo_bg","Rollover User info background color","color"),
	array("styles_userinfo_pic_bg","Rollover User info picture background color","color"),	
	array("styles_userinfo_txt","Rollover User info text color","color"),
	array("styles_roomlist_title_txt_color","Roomlist title text color","color"),
	array("styles_scrollbar_bg_color","Scroll bars background color","color"),	
	array("styles_scrollbar_color","Scroll bars slider color","color"),	
	array("styles_scrollbar_arrow","Scroll bars arrow color","color"),
	array("styles_buttons_bg","Buttons background color","color"),
	array("styles_buttons_text","Buttons text color","color"),
	array("styles_userlist_tab_bg","Userlist tab background color","color"),
	array("styles_userlist_tab_line","Userlist tab line color","color"),	
	array("styles_userlist_tab_selected_text","Userlist tab selected text color","color"),	
	array("styles_userlist_tab_text","Userlist tab text color","color"),
	array("styles_userlist_tab_text_rollover","Userlist tab text roll over color","color"),
	array("styles_window_background","Windows background color","color"),
	array("styles_window_text","Windows text color","color"),
	array("styles_window_title_bg","Windows title bar background color","color"),
	array("styles_window_title_text","Windows title bar text color","color"),
	array("styles_window_link_text_color","Windows links color","color"),
	array("styles_tab_color","Window Tab background color","color"),
	array("styles_tab_text_color","Window Tab text color","color"),	
	array("styles_tab_selected_text_color","Window Tab  selected text color","color"),	
	array("styles_taskbar_bg_color","Minimized private message background color","color"),
	array("styles_viewcam_text_color","View webcam window text color","color"),	
	array("styles_viewcam_bg_color","View webcam window background color","color"),	
	array("styles_viewcam_video_bg_color","View webcam video background color","color"),		
	array("styles_viewcam_border_color","View webcam window border color","color"),	
	array("styles_minibutton_bg","Mini buttons background color","color"),
	array("styles_minibutton_border","Mini buttons border color","color"),
	array("styles_games_bgcolor","Games background color","color"),
	array("styles_games_rollOver","Games item roll over color","color"),
	array("styles_games_text","Games text color","color"),
	array("styles_GCComboTextColor","Combobox text color","color"),
	array("styles_GCComboBackground","Combobox background color","color"),
	array("styles_GCComboitemRollOverColor","Combobox item rollover color","color"),
	array("styles_GCComboselectionBackgroundColor","Combobox selection background color","color"),
	array("styles_GCComboscrollbarColor","Combobox scrollbar color","color"),
	array("styles_GCComboscrollbarBGColor","Combobox scrollbar background color","color"),
	array("styles_default_guest_font_color","Default font color for users (leave blank for random)","color"),
	array("styles_default_admin_user_color","Color of admin users in the userlist","color"),
	array("styles_default_mod_user_color","Color of moderator users in the userlist","color"),
	array("styles_default_premium_user_color","Color of premium users in the userlist","color"),
	array("styles_default_user_user_color","Color of registered users in the userlist","color"),
	array("styles_default_guest_user_color","Color of guest users in the userlist","color")
);
$members_table = $setting->get("members_table");
$room_table = $setting->get("room_table");
$temp_pictures_table = $setting->get("temp_pictures_table");
$username_field = $setting->get("username_field");
$picture_field = $setting->get("picture_field");
$result 	= "";

if($_GET["ac"]=="u" && $_POST["savesetting"]=="yes"){
	if($_SESSION["visichat_access"]=="1"){
		for($i=0;$i<count($chat_styles);$i++){
			$mod = $chat_styles[$i];
			if($mod[2]=="checkbox"){
				if(post("set".$mod[0])=="yes"){
					$value = "yes";
				}else{
					$value = "no";
				}
			}else{
				$value = post("set".$mod[0]);
			}
			$setting->set($mod[0],$value);
		}
		$setting->save();
		$result = "Styles updated successfully.";
	}else{
		$result = "You don't have access to this function";
	}	
}


?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Gchats Visichat Admin Menu: Styles</title>
<link href="../images/style.css" rel="stylesheet" type="text/css" />
<script language="javascript">
function check_confirm(){
	var res = confirm("Are you sure?");
	return res;
}
</script>
<script language="javascript" src="../scripts/picker.js"></script>
<link href="../images/picker.css" rel="stylesheet" type="text/css" />
<style type="text/css">
<!--
#Layer2 {
	position:absolute;
	left:5%;
	top:50px;
	width:90%;
	height:10px;
	z-index:2;
}
-->
</style>
</head>
<body>
<div id="Layer1" align="center" style="position:absolute;left:5;top:5;width:90;height:90;z-index:1;"><a href="menu.php"><img src="../images/return.jpg" width="54" height="54" border="0"><br>
  </a><a href="menu.php" class="YellowText">Return...</a></div>
<div id="Layer2" align="center" class="whileText"><?php echo $result;?></div>
<br />
<br />
<br>
<br>
<br>
<table width="800" border="0" align="center" cellpadding="0" cellspacing="0" class="TMain">
  <tr>
    <td width="2" height="18"><img src="../images/r1.gif" width="2" height="18" /></td>
    <td width="300" align="left" background="../images/r2.gif"><strong>&nbsp;&nbsp; Styles Administration </strong></td>
    <td width="7"><img src="../images/r3.gif" /></td>
    <td background="../images/r4.gif">&nbsp;</td>
    <td width="2"><img src="../images/r5.gif" /></td>
  </tr>
</table>
<table width="800" border="0" align="center" cellpadding="5" cellspacing="0">
  <tr>
    <td width="2" background="../images/r6.gif"></td>
    <td  align="left" valign="top" background="../images/bgdot.gif" class="TextBlack12">
	<form name="form1" method="post" action="styles.php?ac=u">
        <table width="550" border="0" align="center" cellpadding="3" class="TextBlack12">

          <tr>
            <td colspan="2" align="center" bgcolor="#284172" class="whileText"><strong>Styles</strong></td>
          </tr>
          <?php for($i=0;$i<count($chat_styles);$i++){
			$mod = $chat_styles[$i];
		?>
          <tr>
            <td align="right" bgcolor="#FFFFFF" ><?php echo $mod[1];?></td>
            <td align="left" bgcolor="#FFFFFF" >
			<?php echo writeField($mod[2],"set".$mod[0],stripslashes($setting->get($mod[0])),$mod[3]);?>
			</td>
          </tr>
          <?php }?>
           <tr>
            <td colspan="2" align="center" bgcolor="#FFFFFF"><input type="submit" name="Submit" value="Save Setting"></td>
          </tr>
        </table>
        <br>
        <input type="hidden" name="savesetting" value="yes">
    </form>
      <br></td>
    <td width="2" background="../images/r7.gif"></td>
  </tr>
</table>
<table width="800"  height="2" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td width="2" height="2"><img src="../images/r8.gif" width="2" height="2" /></td>
    <td style="background-image:url(../images/r9.gif); font-size:1px;">&nbsp;</td>
    <td height="2" width="2"><img src="../images/r10.gif" /></td>
  </tr>
</table>
</body>
</html>

<?php
function writeField($type,$name,$value,$help){
	switch($type){
		case 'checkbox':
			echo '<input type="checkbox" name="'.$name.'" value="yes"';
			if($value != "no"){
				echo 'checked="checked"';
			}
			echo ' >';
		break;
		case 'textarea':
			echo '<textarea name="'.$name.'" cols="25" rows="3">'.$value.'</textarea>';
		break;
		case 'int':
			echo '<input type="text" id="'.$name.'" style="background-color:#FFFFFF;" name="'.$name.'" maxlength="3" size="3" value="'.$value.'" onkeypress="var k = event.keyCode ? event.keyCode :event.charCode ? event.charCode : event.which; return /^(\d)$/.test(String.fromCharCode(k) );">';
		break;
		case 'color':
			echo '<input type="text" id="'.$name.'" style="background-color:'.$value.';" name="'.$name.'" value="'.$value.'" >';
			echo '<span onClick="openPicker(\''.$name.'\')" class="picker_layer" style="cursor:crosshair;">Pick Color</span>';
		break;
		default:
			echo '<input type="text" id="'.$name.'"  name="'.$name.'" value="'.$value.'" >';
		break;
	}
	if($help != ""){
		echo '<img src="../images/help.jpg" align="absmiddle" title="'.$help.'" />';
	}

}?>