<?php
/****************************************************************************\|
| Gchats Visichat		                                               		  |
| Copyright (c) 2007-2012 Gchats http://www.gchats.com      				  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT"  |
| FILE PROVIDED WITH THIS DISTRIBUTION.                                       |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| GCHATS Visichat 2.0 PROGRAM WITH  THIS  AGREEMENT.                          |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Gchats.com			          |
\*****************************************************************************/
include_once("scripts/library/nocache.php");
include_once("scripts/library/factory.php");
$factory 	= new factory();
$config		= $factory->getInstance("config");
$db 		= $factory->get_db();
$setting 	= $factory->getInstance("GSetting");
$language	= $factory->getInstance("language");

$visichat_url = substr($_SERVER["PHP_SELF"],0,strlen($_SERVER["PHP_SELF"])-12);
$visichat_url = "http://".$_SERVER["HTTP_HOST"].$visichat_url;

$language->language = $setting->get("language");
$language->load();

if ($setting->get("pass_encrypt") != "md5" && $setting->get("pass_encrypt") != "plain")
{
	die("Password recovery is not possible as your script.");

}

// Error message variable
$error 			= "";

// Display when password recovery email is being send
$finish			=false;

// Allow change password
$allow_change	= false;

$password_changed = false;

if (get("ac") == "reset")
{
	$valid = true;
	$res = $db->run_query("select * from ".$setting->get("members_table")." where ".$setting->get("id_field")."='".$db->escape_string(get("u"))."'");
	if($db->get_num_rows($res)==0){
		$error = "<li>".$language->get("invalid_user")."</li>";
		$valid = false;
	}
	else
	{
		$row = $db->fetch_assoc($res);
	}
	$db->free_result($res);
	
		// check code
	$res = $db->run_query("select * from ".$config->prefix."password_recovery where user_id=".$db->escape_string(get("u"))." and keycode='".$db->escape_string(get("key"))."'");

	if($db->get_num_rows($res)==0){
		$error = "<li>".$language->get("invalid_user")."</li>";
		$valid = false;
	}
	$db->free_result($res);
	
	if($valid)
	{
		if( get("post") == "yes")
		{
			if(post("newPassword") == "")
			{
				$error = "<li>".$language->get("passwordreq")."</li>";
			}
			else
			{
				if ( post("newPassword") != post("confirmPassword"))
				{
					$error = "<li>".$language->get("confirm_match")."</li>";
				}
				else
				{
					$password = post("newPassword");
					if($setting->get("pass_encrypt") == "md5")
					{
						$password = md5(post("newPassword"));
					}
					// Change the password
					$db->run_query("update ".$setting->get("members_table")." set ".$setting->get("password_field")."='".$db->escape_string($password)."' where ".$setting->get("id_field")."=".$db->escape_string(get("u")));
					$db->run_query("delete from ".$config->prefix."password_recovery where user_id=".$db->escape_string(get("u"))." or r_date<".(time()-(48*3600)));
					$password_changed = true;
				}
			}
		}
		$allow_change = true;
	
	}

}

if (get("ac") == "recover")
{
	$valid = true;
	if (post("edtUsername") == "")
	{
		$error = "<li>".$language->get("emailreq")."</li>";
		$valid = false;
	}
	else
	{
		$res = $db->run_query("select * from ".$setting->get("members_table")." where ".$setting->get("email_field")."='".$db->escape_string(post("edtUsername"))."'");	
		if ($db->get_num_rows($res) == 0)
		{
			$error = "<li>".$language->get("forgot_passsword_notfound")."</li>";
			$valid = false;		
		}
		else
		{
			$row = $db->fetch_assoc($res);
		}
		$db->free_result($res);
	}
	
	if ($valid){
		$check = $db->run_query("select * from ".$config->prefix."password_recovery where user_id=".$db->escape_string($row[$setting->get("id_field")])." order by r_date desc");
		if($db->get_num_rows($check)>0){
			$checkrow = $db->fetch_assoc($check);
			if(date("F j, Y") == date("F j, Y",$checkrow["r_date"])){
				$error = "<li>".$language->get("forgot_passsword_already")."</li>";
				$db->free_result($check);
				$valid = false;
			}
		}
	}
	
	if($valid)
	{
		$key1 = md5(md5(rand("1111111111","999999999999")).rand("1111111111","999999999999"));
		$key2 = md5(md5(rand("1111111111","999999999999")).rand("1111111111","999999999999"));
		$key = md5($key1.$key2);


		$link = $visichat_url."/recover.php?ac=reset&u=".$row[$setting->get("id_field")]."&key=".$key;
		
		
		$subject = $language->get("forgot_password_subject");
		$body = $language->get("forgot_password_text1",$row[$setting->get("username_field")]);
		$body .= "<br><br>".$language->get("forgot_password_text2");
		$body .= "<br><br>".$language->get("forget_password_link");
		$body .= "<br><br><a href='".$link."'>".$link."</a>";
		$body .= "<br><br>".$language->get("forgot_password_text4");
		$body .= "<br><br>".$language->get("forgot_password_text5");
		$body .= "<br>".$setting->get("website_title");
						
		// Send password reset instructions
		if($factory->sendEmail($row[$setting->get("email_field")],$subject,$body)){
			// Delete old requests from this user from DB and also requests which are older than 2 days
			$db->run_query("delete from ".$config->prefix."password_recovery where user_id=".$db->escape_string($row[$setting->get("id_field")])." or r_date<".(time()-(48*3600)));
			$db->run_query("insert into ".$config->prefix."password_recovery(user_id,r_date,ip,keycode) values(".$db->escape_string($row[$setting->get("id_field")]).",".time().",'".$db->escape_string($_SERVER['REMOTE_ADDR'])."','".$db->escape_string($key)."')");
			$finish = true;
		}else{
			$error = "<li>".$language->get("forgot_passsword_failed")."</li>";
		}		
	
	}
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title><?php echo $language->get("forgot_password");?></title>
<style type="text/css">
<!--
.windows_body thead td{
	background-color: <?php echo $setting->get("styles_window_title_bg");?>;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: <?php echo $setting->get("styles_window_title_text");?>;
}
.windows_body td{
	background-color: <?php echo $setting->get("styles_window_background");?>;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: <?php echo $setting->get("styles_window_text");?>;
}
-->
</style>
</head>
<body>

<?php 
if ( $error != "" )
{
?>
<div align="center" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; color:#FF0000;">
	<div style="width:300px; text-align:left; background-color:#FFFF99; padding:5px; padding-left:22px; border-bottom-color:#FFCC00; border-width:1px; border-style:solid; margin:5px;" align="center">
		<?php echo $error;?>
	</div>
</div>
<?php
}
?>
<?php
if ($password_changed)
{
?>
  <table width="400" border="0" align="center" cellpadding="2" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; border-width:1px; border-style:solid; border-color:#3399CC;" class="windows_body">
  <thead>
    <tr>
      <td align="center" bgcolor="#C2D7E2"><strong><?php echo $language->get("forgot_password");?></strong></td>
    </tr>
	</thead>
    <tr>
      <td align="center" bgcolor="#EEF3F7"><?php echo $language->get("forgot_password_success");?> <br /><br /><?php echo $language->get("redirecting");?> <meta http-equiv="Refresh" content="5;URL=../" /></td>
    </tr>
  </table>
<?php
// Display email activation page
}
else if ( $finish )
{
?>
  <table width="400" border="0" align="center" cellpadding="2" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; border-width:1px; border-style:solid; border-color:#3399CC;" class="windows_body">
  <thead>
    <tr>
      <td align="center" bgcolor="#C2D7E2"><strong><?php echo $language->get("forgot_password");?></strong></td>
    </tr>
	</thead>
    <tr>
      <td align="center" bgcolor="#EEF3F7"><?php echo $language->get("forgot_passsword_sent");?> <br /><br /><?php echo $language->get("redirecting");?> <meta http-equiv="Refresh" content="3;URL=../" /></td>
    </tr>
  </table>
<?php
}
else if ($allow_change)
{
?>
<form id="form2" name="form2" method="post" action="?ac=reset&post=yes&ln=<?php echo get("ln");?>&u=<?php echo get("u");?>&key=<?php echo get("key");?>">
  <table width="500" border="0" align="center" cellpadding="4" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; border-width:1px; border-style:solid; border-color:#3399CC;" class="windows_body">
  <thead>
    <tr>
      <td colspan="2" align="center" bgcolor="#C2D7E2"><strong><?php echo $language->get("forgot_password_subject");?>
        <input type="hidden" name="u" value="<?php echo $row[$setting->get("id_field")];?>" />
      </strong></td>
    </tr>
	</thead>
    <tr>
      <td align="right" bgcolor="#EEF3F7" width="50%"><?php echo $language->get("username");?></td>
      <td align="left" bgcolor="#EEF3F7"><B><?php echo $row[$setting->get("username_field")];?></B></td>
    </tr>
    <tr>
      <td align="right" bgcolor="#EEF3F7" width="50%"><?php echo $language->get("new_password");?></td>
      <td align="left" bgcolor="#EEF3F7"><input type="password" name="newPassword" /></td>
    </tr>
    <tr>
      <td align="right" bgcolor="#EEF3F7" width="50%"><?php echo $language->get("new_password_confirm");?></td>
      <td align="left" bgcolor="#EEF3F7"><input type="password" name="confirmPassword" /></td>
    </tr>	
    <tr>
      <td colspan="2" align="center" bgcolor="#EEF3F7"><input type="submit" name="Submit2" value="<?php echo $language->get("accept");?>" /></td>
    </tr>			
  </table>
</form>  
<?php
}
else
{
?>
<form id="form1" name="form1" method="post" action="?ac=recover&ln=<?php echo get("ln");?>">
  <table width="400" border="0" align="center" cellpadding="2" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; border-width:1px; border-style:solid; border-color:#3399CC;" class="windows_body">
  <thead>
    <tr>
      <td colspan="2" align="center" bgcolor="#C2D7E2"><strong><?php echo $language->get("forgot_password");?></strong></td>
    </tr>
	</thead>
    <tr>
      <td align="right" bgcolor="#EEF3F7"><?php echo $language->get("email");?></td>
      <td bgcolor="#EEF3F7"><input name="edtUsername" type="text" id="edtUsername" value="<?php echo post("edtUsername");?>" /></td>
    </tr>
    <tr>
      <td colspan="2" align="center" bgcolor="#EEF3F7"><input type="submit" name="Submit" value="<?php echo $language->get("send");?>" style="background-color:<?php echo $setting->get("styles_buttons_bg");?>; color:<?php echo $setting->get("styles_buttons_text");?>;" /></td>
    </tr>
  </table>
</form>
<?php
}
?>
</body>
</html>
<?php
$db->close();
?>