<?php
include_once("scripts/library/nocache.php");
include_once("scripts/library/factory.php");
$factory 	= new factory();
$db 		= $factory->get_db();
$setting 	= $factory->getInstance("GSetting");
$language	= $factory->getInstance("language");


$visichat_url = substr($_SERVER["PHP_SELF"],0,strlen($_SERVER["PHP_SELF"])-12);
$visichat_url = "http://".$_SERVER["HTTP_HOST"].$visichat_url;

$language->language = $setting->get("language");
$language->load();


// Error message variable
$error 			= "";
// Display verification page
$verification 	= false;
// Display successful registeration
$finish			=false;

if( get("ac") == "activate" )
{
	if (get("username") != "")
	{
		$_POST["edtUsername"] = get("username");
	}
	$verification 	= true;
}

if( get("ac") == "finish" )
{
	$finish 	= true;
}

// To avoid conflict, do not register if visichat is integrated
if($setting->get("integrate") != "")
{
	die("Registeration is not enabled when visichat is integrated in another script.");
}

if($setting->get("register") != "yes")
{
	die("Currently registeration is disabled by system administrator");
}

if(get("ac") == "register")
{
	$valid = true;
	
	// Check if username is blank
	if(post("edtUsername") == "")
	{
		$valid = false;
		$error .= "<li>".$language->get("usernamereq")."</li>";
	} 
	// Check if username length is good
	else if ( strlen(post("edtUsername"))<4 || strlen(post("edtUsername"))>30)
	{
		$valid = false;
		$error .= "<li>".$language->get("username_4_30")."</li>";	
	}
	else 
	{
	// Check if username is not already taken
		$res = $db->run_query("select * from ".$setting->get("members_table")." where ".$setting->get("username_field")."='".$db->escape_string(post("edtUsername"))."'");	
		if( $db->get_num_rows($res) > 0 )
		{
			$valid = false;
			$error .= "<li>".$language->get("already_taken")."</li>";
		}	
		$db->free_result($res);
	}

	if( $valid && ( preg_match_all('/[-_]/', post("edtUsername"), $matches, PREG_OFFSET_CAPTURE) >3  || preg_match('|[\\\:*?<>\|\/\[\]{}()%\^&!@$\'"`~,]|', post("edtUsername")) >0 )){
		$valid = false;
		$error .= "<li>".$language->get("invalid_user")."</li>";	
	}
	
	// Check password
	if(post("edtPassword") == "")
	{
		$valid = false;
		$error .= "<li>".$language->get("passwordreq")."</li>";
	}
	
	// Check if password and confirm are match
	if(post("edtConfirm") != post("edtPassword"))
	{
		$valid = false;
		$error .= "<li>".$language->get("confirm_match")."</li>";
	}
	
	// Check if email address is blank
	if(post("edtEmail") == "")
	{
		$valid = false;
		$error .= "<li>".$language->get("emailreq")."</li>";
	}
	// Check if email address is valid
	else if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@rocketmail*\.com$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@yahoo*\.in$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@yahoo*\.com$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@yahoo*\.co.uk$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@hotmail*\.com$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@hotmail*\.co.uk$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@hotmail*\.de$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@hotmail*\.ca$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@live*\.com$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@live*\.fr$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@live*\.co.uk$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@live*\.ca$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@live*\.com.pk$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@hotmail*\.com.pk$/i',post("edtEmail"))==0)
	if (preg_match('/^[A-Z0-9_-][A-Z0-9._-]*@gmail*\.com$/i',post("edtEmail"))==0)
	{
		$valid = false;
		$error .= "<li>".$language->get("invalid_email")."</li>";	
	}
	// Now checking if email address is not already registered
	else
	{
		$res = $db->run_query("select * from ".$setting->get("members_table")." where ".$setting->get("email_field")."='".$db->escape_string(post("edtEmail"))."'");	
		if( $db->get_num_rows($res) > 0 )
		{
			$valid = false;
			$error .= "<li>".$language->get("email_taken")."</li>";
		}	
		$db->free_result($res);
	
	}
	// Check for multiple account registeration with one ip
	if( $setting->get("allow_dulplicate_ip_register") != "yes")
	{
		$res = $db->run_query("select * from ".$setting->get("members_info_table")." where visi_chat_user_ip='".$db->escape_string($_SERVER['REMOTE_ADDR'])."'");
		if($db->get_num_rows($res) >0)
		{
			$valid = false;
			$error = "<li>".$language->get("duplicate_ip_registeration")."</li>";
		}
		$db->free_result($res);
	
	}
	
	// If everything is ok
	if($valid)
	{
		// Variables
		$username	= post("edtUsername");
		$password	= post("edtPassword");
		$email		= post("edtEmail");
		
		// Email activation code
		$code = rand(11111111,99999999);
		
		// Register the user
		$db->run_query("insert into ".$setting->get("members_table")." (".$setting->get("username_field").",".$setting->get("password_field").",".$setting->get("email_field").") values ('".$db->escape_string($username)."','".$db->escape_string(md5($password))."','".$db->escape_string($email)."')");
		
		$res = $db->run_query("select * from ".$setting->get("members_table")." where ".$setting->get("username_field")."='".$db->escape_string($username)."'");
		if($db->get_num_rows($res)>0){
			$row = $db->fetch_assoc($res);
			$db->run_query("delete from ".$setting->get("members_info_table")." where visi_chat_user_id=".$db->escape_string($row[$setting->get("id_field")]));
			$db->run_query("insert into ".$setting->get("members_info_table")." (visi_chat_user_id,visi_chat_user_ip,visi_chat_gender,visi_chat_email_code,visi_chat_signup_time,visi_chat_login_time,visi_chat_user_banned,visi_chat_is_online,visi_chat_timely_ban,visi_chat_is_mod,visi_chat_allow_private) values(".$db->escape_string($row[$setting->get("id_field")]).",'".$db->escape_string($_SERVER['REMOTE_ADDR'])."','n','".$db->escape_string($code)."',".time().",0,0,0,0,0,1)");
		}
		$db->free_result($res);
		
		// Email activation
		if( $setting->get("email_activation") == "yes")
		{
			$verify_link = $visichat_url."register.php?ac=activate&code=".$code."&username=".$username."&post=yes&ln=".get("ln");
			$break = "<br>";
			$email_message = $language->get("forgot_password_text1",$username).$break.$break.$language->get("register_email_text1",$setting->get("website_title")).'.'.$break.$break.$language->get("register_email_text2",$setting->get("website_title")).'.'.$break.$break;
			$email_message .=  $language->get("register_email_text3").$break.$break."<a href='".$verify_link."'>".$verify_link."</a>".$break.$break.$language->get("forgot_password_text5").','.$break.$setting->get("website_title");
			
			$factory->sendEmail($email,$setting->get("website_title")." ".$language->get("validate_title"),$email_message);
			$verification = true;
			$db->close();
			?>
			<script language="javascript">
				window.alert('<?php echo addslashes($language->get("validate_text"));?>');
				window.location = '<?php echo "register.php?ac=activate&ln=".get("ln")."&username=".$username; ?>';
			</script>
			<?php
			exit();
		}
		else
		{
			$db->close();
			header("location: register.php?ac=finish");
			exit();
		}
	}
}

if( get("ac") == "activate" && get("post") == "yes")
{
	$valid = true;
	
	// Check if username is blank
	if(post("edtUsername") == "")
	{
		$valid = false;
		$error .= "<li>".$language->get("usernamereq")."</li>";
	} 	
	
	if ($valid)
	{	
		if(get("code") != "" && post("edtCode") == "")
		{
			$_POST["edtCode"] = get("code");
		}
		// Check if username exists
		$res = $db->run_query("select * from ".$setting->get("members_table")." where ".$setting->get("username_field")."='".$db->escape_string(post("edtUsername"))."'");
		if( $db->get_num_rows($res) == 0 )
		{
			$error .= "<li>".$language->get("invalid_user")."</li>";
		}
		else
		{
			$row = $db->fetch_assoc($res);
			$check = $db->run_query("select * from ".$setting->get("members_info_table")." where visi_chat_user_id=".$db->escape_string($row[$setting->get("id_field")]));
			if($db->get_num_rows($check) == 0)
			{
				$error .= "<li>".$language->get("invalid_user")."</li>";
			}
			else
			{
				$check_row = $db->fetch_assoc($check);
				if($check_row["visi_chat_email_code"] == post("edtCode"))
				{
					$db->run_query("update ".$setting->get("members_info_table")." set visi_chat_email_verified =1 where visi_chat_user_id=".$db->escape_string($row[$setting->get("id_field")]));
					$finish = true;
				}
				else
				{
					$error .= "<li>".$language->get("invalid_code")."</li>";
				}
			}
			$db->free_result($check);
		}	
		$db->free_result($res);
	}

}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Registeration</title>
<style type="text/css">
<!--
.windows_body thead td{
	background-color: <?php echo $setting->get("styles_window_title_bg");?>;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: <?php echo $setting->get("styles_window_title_text");?>;
}
.windows_body td{
	background-color: <?php echo $setting->get("styles_window_background");?>;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: <?php echo $setting->get("styles_window_text");?>;
}
-->
</style>
</head>
<body>

<?php 
if ( $error != "" )
{
?>
<div align="center" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; color:#FF0000;">
	<div style="width:300px; text-align:left; background-color:#FFFF99; padding:5px; padding-left:22px; border-bottom-color:#FFCC00; border-width:1px; border-style:solid; margin:5px;" align="center">
		<?php echo $error;?>
	</div>
</div>
<?php
}
?>

<?php
// Display email activation page
if ( $finish )
{
?>
  <table width="400" border="0" align="center" cellpadding="2" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; border-width:1px; border-style:solid; border-color:#3399CC;" class="windows_body">
  <thead>
    <tr>
      <td align="center" bgcolor="#C2D7E2"><strong><?php echo $language->get("registeration_form");?></strong></td>
    </tr>
	</thead>
    <tr>
      <td align="center" bgcolor="#EEF3F7"><?php echo $language->get("register_success");?> <br /><br /><?php echo $language->get("redirecting");?> <meta http-equiv="Refresh" content="3;URL=./" /></td>
    </tr>
  </table>
<?php
}
else if ($verification)
{
?>
<form id="form2" name="form2" method="post" action="?ac=activate&post=yes&ln=<?php echo get("ln");?>">
  <table width="500" border="0" align="center" cellpadding="4" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; border-width:1px; border-style:solid; border-color:#3399CC;" class="windows_body">
  <thead>
    <tr>
      <td align="center" bgcolor="#C2D7E2"><strong><?php echo $language->get("validate_title");?></strong></td>
    </tr>
	</thead>
    <tr>
      <td align="center" bgcolor="#EEF3F7"><?php echo $language->get("validate_text");?></td>
    </tr>
  </table>
</form>  
<?php
}
else
{
?>
<script language="javascript" type="text/javascript">
function removeSpaces(string) {
 return string.split(' ').join('');
}
</script>
<form id="form1" name="form1" method="post" action="?ac=register&ln=<?php echo get("ln");?>">
  <table width="400" border="0" align="center" cellpadding="2" style="font-family:Arial, Helvetica, sans-serif; font-size:12px; border-width:1px; border-style:solid; border-color:#3399CC;" class="windows_body">
  <thead>
    <tr>
      <td colspan="2" align="center" bgcolor="#C2D7E2"><strong><?php echo $language->get("registeration_form");?></strong></td>
    </tr>
	</thead>
    <tr>
      <td align="right" bgcolor="#EEF3F7"><?php echo $language->get("username");?></td>
      <td bgcolor="#EEF3F7"><input name="edtUsername" type="text" onblur="this.value=removeSpaces(this.value)" id="edtUsername" value="<?php echo post("edtUsername");?>" /></td>
    </tr>
    <tr>
      <td align="right" bgcolor="#EEF3F7"><?php echo $language->get("password");?></td>
      <td bgcolor="#EEF3F7"><input name="edtPassword" type="password" id="edtPassword" /></td>
    </tr>
    <tr>
      <td align="right" bgcolor="#EEF3F7"><?php echo $language->get("confirm");?></td>
      <td bgcolor="#EEF3F7"><input name="edtConfirm" type="password" id="edtConfirm" /></td>
    </tr>
    <tr>
      <td align="right" bgcolor="#EEF3F7"><?php echo $language->get("email");?></td>
      <td bgcolor="#EEF3F7"><input name="edtEmail" type="text" id="edtEmail" value="<?php echo post("edtEmail");?>" /></td>
    </tr>
    <tr>
      <td colspan="2" align="center" bgcolor="#EEF3F7"><input type="submit" name="Submit" value="<?php echo $language->get("register");?>" style="background-color:<?php echo $setting->get("styles_buttons_bg");?>; color:<?php echo $setting->get("styles_buttons_text");?>;" /></td>
    </tr>
  </table>
</form>
<?php
}
?>
</body>
</html>
<?php
$db->close();
?>