<?php
/****************************************************************************\|
| Gchats Visichat		                                               		  |
| Copyright (c) 2007-2012 Gchats http://www.gchats.com      				  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT"  |
| FILE PROVIDED WITH THIS DISTRIBUTION.                                       |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| GCHATS Visichat 2.0 PROGRAM WITH  THIS  AGREEMENT.                          |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Gchats.com			          |
\*****************************************************************************/
include_once(dirname(__FILE__)."/factory.php");

class setting{
	var $factory;
	var $config;
	var $db;
	var $property;
	var $user_levels = array("admin","mod","premium","user","guest");
	var $password_encryptions = array(array("Plain (not encrypted)","plain"),array("MD5","md5"),array("SHA1","sha1"),array("VBulletin System","vb"),array("Joomla System","joomla"),array("MyBB System","MyBB"),array("PHPBB 3 System","phpbb 3"),array("x-cart System","x-cart"),array("SMF System","SMF (Simple Machines Forum)"),array("Social Engine System","SocialEngine"),array("vldPersonals","vldPersonals"),array("wordpress","wordpress"), array("phpfox", "phpfox"), array("SkaDate","skadate"), array("IP Board","ipboard"));
	var $permissions = array(
		array("create_room","Create rooms","11110","11110","boolean"),
		array("create_private_room","Create password protected rooms","11110","11110","boolean"),
		array("allow_join_private_room","Allow join the password protected rooms","11111","11111","boolean"),
		array("open_webcam","Turn on Webcam","11111","11111","boolean"),
		array("view_webcam","View Webcam","11111","11111","boolean"),
		array("set_cam_status","Set webcam display status","11111","11111","boolean"),
		array("view_cam_permission","View webcam without permission","11111","11000","boolean"),	
		array("view_multiple_cam","View Multiple Webcams","11111","11111","boolean"),
		array("gallery_access","Access to video gallery","11111","11111","boolean"),
		array("gallery_record","Record movies in the gallery","11110","11110","boolean"),
		array("public_voice","Public Voice","11111","11111","boolean"),
		array("private_voice","Private voice","11111","11111","boolean"),
		array("private_msg","Start private message","11111","11111","boolean"),
		array("drawing","Drawing board","11111","11111","boolean"),	
		array("allow_send_links","Allowed send links in the private and public chat","11111","11111","boolean"),		
		array("public_pic_share","Public file & pic share and remote picture upload","11110","11110","boolean"),
		array("private_pic_share","Private file & pic share","11110","111110","boolean"),
		array("allow_prv_open_cam","Allow open camera from private chat window","11111","11111","boolean"),
		array("allow_clear_screen","Allow clear screen of all of the users","11000","11000","boolean"),
		array("show_cam_icon","Can view webcam icon in the user list","11111","111111","boolean"),
		array("allow_view_men_cam","Allowed to view men's webcam","00111","111111","boolean"),
		array("allow_view_women_cam","Allowed to view women's webcam","00111","111111","boolean"),
		array("allow_view_other_cam","Allowed to view other user's webcam","00111","111111","boolean"),
		array("allow_post_youtube","Allowed to post YouTube videos","11111","11110","boolean"),
		array("show_ip","Display IP address of users","11000","11000","boolean"),
		array("allow_kick_premium","Allow to kick/ban premium users","11000","11000","boolean"),
		array("allow_delete_rooms","Allowed delete user created rooms","1100","11000","boolean"),
		array("allow_manage_button","Allow access to the Manage window","1100","11000","boolean"),
		array("allow_kick_users","Allowed access to kick users","1100","11000","boolean"),
		array("allow_ban_ip_users","Allowed access to the Ban IP option","1100","11000","boolean"),
		array("allow_ban_host_users","Allowed access to the Ban Host option","1100","11000","boolean"),
		array("allow_gag_users","Allowed access to the Gag option","1100","11000","boolean"),
		array("allow_take_mic_users","Allowed access to the take mic option","11000","11000","boolean"),
		array("allow_close_cam_users","Allowed access to the close webcam option","11000","11000","boolean"),
		array("allow_join_password_rooms","Allowed access to password protected rooms","11000","11000","boolean"),
		array("allow_view_online_users" , "Allow viewing the online users panel","11000","10000","boolean")
	);
	function setting(){
		$this->factory 	= new factory();
		$this->config 	= $this->factory->getInstance("config");
		$this->db		= $this->factory->get_db();
		$this->load_setting();
		$this->set_defaults();
	}
	
	function set($key,$value){
		$this->property[$key] = $value;
		ksort($this->property);
	}
	
	function get($key){
		if(isset($this->property[$key])){
			if($this->property[$key]==" "){
				return "";
			}
			return $this->property[$key];
			
		}else{
			return "";
		}
	}
	
	function load_setting(){
		$res = $this->db->run_query("select * from ".$this->config->prefix."setting");
		for($i=0;$i<$this->db->get_num_rows($res);$i++){
			$row = $this->db->fetch_assoc($res,$i);
			$this->property[$row["set_property"]] = $row["set_value"];
		}
		$this->db->free_result($res);
	
	}
	
	function set_defaults(){
	
		// default values
		$default["members_table"]		= $this->config->prefix."members";
		$default["members_info_table"]	= $this->config->prefix."members_info";
		$default["admin_users_table"]	= $this->config->prefix."admin_users";
		$default["panel_users_table"]	= $this->config->prefix."panel_users";
		$default["mod_users_table"]	    = $this->config->prefix."mod_users";
		$default["temp_pictures_table"]	= $this->config->prefix."temp_pictures";
		$default["room_table"]			= $this->config->prefix."rooms";
		$default["log_history_table"]	= $this->config->prefix."log_history";
		$default["room_users_table"]	= $this->config->prefix."room_users";
		$default["banip_table"]			= $this->config->prefix."banip";
		$default["gallery_movies_table"]= $this->config->prefix."gallery_movies";
		$default["banner_table"]		= $this->config->prefix."banners";
		$default["badwords_table"]		= $this->config->prefix."badwords";
		// Members Fields
		$default["id_field"]			= "id";
		$default["username_field"]		= "username";
		$default["password_field"]		= "passmd5";
		$default["email_field"]			= "email";		
		$default["picture_field"]		= "visi_chat_picture";
		$default["gender_field"]		= "visi_chat_gender";
		$default["user_access_field"]	= "visi_chat_paid_user";
		$default["badwords_field"] 		= "badword";
		// Chat server setting
		$default["chat_app"]			= "visichat2";
		$default["language"]			= "en";
		$default["pass_encrypt"]		= "md5";
		$default["email_activation"]	= "no";
		$default["delete_non_activated"]  = "no";
		$default["visichat_path"]		= "";
		$default["date_format"]		= "F j, Y";
		$default["show_private_rooms"]	= "yes";
		$default["memberlist_count"]	= "50";
		$default["user_access_enabled"]	= "no";
		$default["max_file_size"]		= "200";
		$default["picture_path"]		= "members/";
		$default["thumbnail_path"]		= "members/thumbnails/";
		$default["gallery_record_sec"]	= "10";
		$default["gallery_movie_count"]	= "10";
		$default["gallery_need_approve"]= "yes";
		$default["default_cam_quality"]	= "70";
		$default["allowed_files"] = "gif,jpg,jpeg,png,txt,rtf,doc,pdf,csv,zip,mp3";
		$default["profile_link"] = "";
		$default["register_link"]= "";
		$default["styles_bg_color"] = "#000000";
		$default["styles_alpha"] = "100";
		$default["styles_news_reload"] = "0";
		$default["user_access_allow_value"] = "1";
		$default["user_access_deny_value"] = "0";
		$default["styles_font_size"] = "12";
		$default["public_msg_button_enabled"] ="no";
		$default["public_msg_button2_enabled"] ="no";
		$default["login_turon_webcam"] = "no";
		$default["login_turon_voice"] = "no";
		$default["login_turon_handsfree"] = "no";
		$default["webcam_width"] = 200;
		$default["webcam_height"] = 200;
		$default["user_time_limit"] = "0";
		$default["guest_time_limit"] = "0";
		$default["enable_one_way_chat"] = "no";
		$default["chat_room_open"]="1";
		$default["chat_room_close_msg"] = "Chat room is currently in maintenance mode. Please check back later!";
		$default["disconnect_idle_time"]="0";
		$default["premium_cost"] = "5";
		$default["credit_field"] = "visi_chat_credits";
		$default["premium_add_days"] = "31";
		$default["auto_login"] = "no";
		$default["handraise_talk_limit"] = "60";
		$default["handraise_start_limit"] = "20";
		$default["log_save_time"] ="5";
		$default["styles_max_smileys"] = "10";
		$default["enable_chat_encryption"] = "no";
		$default["show_webcambtn_prv"] = "yes";
		$default["show_adult_room"] = "yes";
		$default["show_couple_label"] = "yes";
		$default["disconnect_cam_room_change"] = "no";
		$default["picture_share_height"] = "100";
		$default["charset"] = "utf-8";
		$default["max_user_list_size"] = "0";
		$default["show_city"] = "no";
		$default["show_country"] = "no";
		$default["show_age"] = "no";
		$default["show_gender"] = "no";
		$default["premium_add_hours"] = "0";
		$default["premium_add_minutes"] = "0";
		$default["closecam_idle_time"] = "0";
		$default["show_away_minutes"] = "0";
		$default["enable_youtube"] = "yes";
		$default["minimize_private_messages"] = "no";
		$default["user_created_room_capacity"] = "40";
		$default["user_created_room_limit"] = "0";
		$default["cam_bandwidth"] = "80";
		$default["open_all_cam_on_login"] = "no";
		$default["media_player_width"] = "400";
		$default["media_player_height"] = "300";
		$default["send_credit_notice"] = "no";
		$default["max_private_message"] = "300";
		$default["max_public_message"] = "300";
		$default["auto_close_confirm"] = "no";
		$default["sound_quality"] = "11";
		$default["cleanup_date"] = 0;
		$default["update_check_date"] = 0;
		$default["cam_frames_persec"] = "6";
		$default["allow_user_delete"] = "no";
		$default["userlist_order"] = "am"; // admin , moderator
		// Set default permissions
		for($i=0;$i<count($this->permissions);$i++){
			$mod = $this->permissions[$i];
			$access =preg_split('//',$mod[3],-1,PREG_SPLIT_NO_EMPTY);
			for($j=0;$j<count($this->user_levels);$j++){
				if($mod[4] =="boolean"){
					if($access[$j]=="1"){
						$value = "yes";
					}else{
						$value = "no";
					}
				}
				if($mod[4] == "int"){
					if($access[$j] == ""){
						$value = "0";
					}else{
						$value = $access[$j];
					}
				}
				$default["perm_".$this->user_levels[$j]."_".$mod[0]] =$value;
			}
		
		}
		// Add default values to empty setting fields
		foreach($default as $i=>$key){
			if(!isset($this->property[$i])){
				$this->set($i,$key);
			}
		}
		
		
	}
	
	// Save setting
	function save(){
		foreach($this->property as $i=>$key){
			$res = $this->db->run_query("select * from ".$this->config->prefix."setting where set_property='".$this->db->escape_string($i)."'");
			if($this->db->get_num_rows($res)>0){
				$this->db->run_query("update ".$this->config->prefix."setting set set_property='".$this->db->escape_string($i)."', set_value='".$this->db->escape_string($key)."' where set_property='".$this->db->escape_string($i)."'");
			}else{
				$this->db->run_query("insert into ".$this->config->prefix."setting (set_property,set_value) values('".$this->db->escape_string($i)."','".$this->db->escape_string($key)."')");
			}
		}
		$this->update();
	}
	
	// Clean up
	function cleanLogs(){
		if($this->get("log_days")>0 && $this->get("log_days") != 0){
			$this->db->run_query("delete from ".$this->config->prefix."log_history where l_date<".(time()-($this->get("log_days")*86400)));
		}
		$this->db->run_query("delete from ".$this->config->prefix."reports where r_date<".(time()-30*86400));
	
	}
	// Create setting file
	
	function update(){
		$handle = @fopen(LIB_PATH.DS.'..'.DS.'..'.DS.'cache/GSetting.php','w');
		if(!$handle ===FALSE){
			@fwrite($handle,"<?php \r\n// This is auto generated file, do not change this file!\r\nclass GSetting{\r");
			
			@fwrite($handle,"var \$property='';\r");
			
			@fwrite($handle,"function GSetting(){\r");
			foreach($this->property as $i=>$key){
			  
				@fwrite($handle,"\$this->property['".base64_encode($i)."']='".base64_encode($key)."';\r");
			}
			@fwrite($handle,"}\r");
			@fwrite($handle,"function get(\$key){\r");
			@fwrite($handle,"if(isset(\$this->property[base64_encode(\$key)])){\r");
			@fwrite($handle,"return base64_decode(\$this->property[base64_encode(\$key)]);\r");
			@fwrite($handle,"}\r");
			@fwrite($handle,"return '';\r");
			@fwrite($handle,'}');
			@fwrite($handle,'} ?>');
		}
		@fclose($handle);
	}

}

?>