<?php
/****************************************************************************\|
| Gchats Visichat		                                               		  |
| Copyright (c) 2007-2012 Gchats http://www.gchats.com      				  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT"  |
| FILE PROVIDED WITH THIS DISTRIBUTION.                                       |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| GCHATS Visichat 2.0 PROGRAM WITH  THIS  AGREEMENT.                          |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Gchats.com			           |
\*****************************************************************************/
include_once(dirname(__FILE__)."/factory.php");
class visichat{
	var $factory;
	var $db;
	var $config;
	var $setting;
	var $members_table;
	var $id_field;
	var $username_field;
	var $password_field;
	// Authenication
	var $authenicated 	= false;
	var $is_moderator	= false;
	var $user_type		= "";
	var $userid			= "";
	var $username		= "";
	var $password		= "";
	var $salt			= "";
	var $votes			= 0;
	var $rate			= 0;
	var $adult			= false;
	function visichat(){
		$this->factory	= new factory();
		$this->db 		= $this->factory->get_db();
		$this->config	= $this->factory->getInstance("config");
		$this->setting	= $this->factory->getInstance("GSetting");
		$this->members_table = $this->setting->get("members_table");
		$this->id_field = $this->setting->get("id_field");
		$this->username_field = $this->setting->get("username_field");
		$this->password_field = $this->setting->get("password_field");
		$this->authenicate();
		
		// Clean up
		$res = $this->db->run_query("select * from ".$this->config->prefix."setting where set_property='cleanup_date'");
		$cleanup_date =0;
		if($this->db->get_num_rows($res)>0){
			$row = $this->db->fetch_assoc($res);
			$cleanup_date = $row["set_value"];
		}
		$this->db->free_result($res);
		if(floor($cleanup_date/86400) < floor(time()/86400)){
			$this->cleanUp();
			$this->check_updates();
			$this->delete_inactive();
			$this->db->run_query("update ".$this->config->prefix."setting set set_value='".time()."' where set_property='cleanup_date'");
		}
	}
	function authenicate(){
		$res = $this->db->run_query("select * from ".$this->config->prefix."online_users as A inner join ".$this->config->prefix."members_info as B on A.visi_online_userid= B.visi_chat_user_id where visi_client_id ='".$this->db->escape_string(post("client_id"))."'");
		if($this->db->get_num_rows($res)>0){
			$row = $this->db->fetch_assoc($res);
			if($_POST["pass"] == md5($row["visi_online_salt"].$row["visi_online_userid"])){	
				$this->authenicated = true;
				$this->userid = $row["visi_online_userid"];
				$this->salt = $row["visi_online_salt"];
				$this->username = $row["visi_online_username"];
				$this->votes = $row["visi_chat_votes"];
				$this->rate = $row["visi_chat_rate"];
				if($row["visi_chat_is_mod"]==1 || $row["visi_chat_is_mod"]==3){
					$this->is_moderator = true;
				}
				$this->user_type = "user";				
				if($row["visi_chat_is_mod"]==1){
					$this->user_type = "mod";
				}
				if($row["visi_chat_is_mod"]==3){
					$this->user_type = "admin";
				}
				if($row["visi_chat_is_mod"]==2){
					if($row["visi_chat_expire"]>time() || $row["visi_chat_expire"]=="0"){
						$this->user_type = "premium";	
					}
				}
				if($row["visi_chat_year_of_birth"]!= "" && $row["visi_chat_year_of_birth"] < date("Y")-18){
					$this->adult = true;
				}
			}
		}
		$this->db->free_result($res);
	}
	function parse($cmd){
		if($this->authenicated){
			switch($cmd){
				case "publicLog":
					//$this->publicLog();
				break;
				case 'privateLog':
					//$this->privateLog();
				break;
				case 'updateProfile':
					$this->updateProfile();
				break;
				case 'saveColor':
					$this->saveColor();
				break;
				case 'vote':
					$this->vote();
				break;
				case 'block':
					$this->block();
				break;
				case 'unblock':
					$this->unblock();
				break;
				case 'addbuddy':
					$this->addbuddy();
				break;
				case 'delbuddy':
					$this->delbuddy();
				break;
				case 'acceptbuddy':
					$this->acceptbuddy();
				break;
				case 'rejectbuddy':
					$this->rejectbuddy();
				break;
				case 'offlineMsg':
					$this->offlineMsg();
				break;
				case 'createRoom':
					$this->createRoom();
				break;
				case 'deleteRoom':
					$this->deleteRoom();
				break;
				case 'voteGame':
					$this->voteGame();
				break;
				case 'loadGateways':
					$this->loadGateways();
				break;
				case 'getcountry':
					$this->getCountry();
				break;
				case 'upload_remote_pic':
					if($this->setting->get("show_webcambtn_prv")!="no"){
				    	$this->upload_remote_pic();
					}
				break;
				case 'report_user':
					$this->report_user();
				break;
	
				case 'getHost':
					if($this->is_moderator){
						$this->getHost();
					}
				break;		
				case 'banHost':
					if($this->is_moderator){
						$this->banHost();
					}
				break;
			}		
		}
		// Commands which does not need authenication
		switch($cmd){
			case 'forgotPass':
				$this->forgotPass();
			break;
			case 'changePassword':
				$this->changePassword();
			break;
		}
	}
	// main functions
	function publicLog(){	
		if($this->setting->get("enable_log") == "yes"){
			$room = $_POST["room"];
			$message = $_POST["message"];
			if(($_POST["to"] == "Left this room" || $_POST["to"] == "Joined this room") && $message == "JoinLeave"){
				$user = "|chat console|";
				$message = $this->username." ".$_POST["to"];
			}else{
				$user = $this->username;
			}
			if($message != "" && $room != ""){
				$this->db->run_query("insert into ".$this->config->prefix."log_history(username,room,l_message,l_date,l_ip,l_to) values('".$this->db->escape_string($user)."','".$this->db->escape_string($room)."','".$this->db->escape_string($message)."',".time().",'".$this->db->escape_string($_SERVER['REMOTE_ADDR'])."','')");
			}
		}
	}
	function privateLog(){
		if($this->setting->get("log_private_msg") == "yes"){
			$room = $_POST["room"];
			$message = $_POST["message"];
			$to = $_POST["to"];
			if($message != "" && $to != ""){
				$this->db->run_query("insert into ".$this->config->prefix."log_history(username,room,l_message,l_date,l_ip,l_to) values('".$this->db->escape_string($this->username)."','".$this->db->escape_string($room)."','".$this->db->escape_string($message)."',".time().",'".$this->db->escape_string($_SERVER['REMOTE_ADDR'])."','".$this->db->escape_string($to)."')");
			}
		}	
	}
	function updateProfile(){
		$year = $_POST["year"];
		$allow_private =1;
		$who_view_mycam=1;
		if(!is_numeric($year) || $year <1900 || $year > date("Y")){$year =0;}
		if($_POST["allow_private"] == "0"){$allow_private =0;}
		if($_POST["allow_private"] == "2"){$allow_private =2;}
		if($_POST["allow_private"] == "3"){$allow_private =3;}
		if($_POST["who_view_mycam"] == "0"){$who_view_mycam=0;}
		if($_POST["who_view_mycam"] == "2"){$who_view_mycam=2;}
		if($_POST["who_view_mycam"] == "3"){$who_view_mycam=3;}
		// User options
		$res = $this->db->run_query("select * from ".$this->members_table." inner join ".$this->config->prefix."members_info on ".$this->members_table.".".$this->id_field."=".$this->config->prefix."members_info.visi_chat_user_id where ".$this->id_field."=".$this->userid);
		if($this->db->get_num_rows($res)>0){
			$row = $this->db->fetch_assoc($res);
			
			// Updating picture
			$pic = $_POST["pic"];
			if(!is_file(LIB_PATH.DS."..".DS."..".DS."members".DS.$pic) && !is_file(LIB_PATH.DS."..".DS."..".DS.$pic)){
				$pic = "";
			}
			if($pic != $row["visi_chat_picture"]){
				unlink(LIB_PATH.DS."..".DS."..".DS."members".DS.$row["visi_chat_picture"]);
				unlink(LIB_PATH.DS."..".DS."..".DS."members".DS."thumbnails".DS.$row["visi_chat_picture"]);
			}
			$user_options = unserialize(base64_decode($row["visi_chat_user_options"]));
			$display_cam =1;
			if($_POST["display_cam"] == "0"){
				$display_cam = 0;
			}
			$enable_sound=1;
			if($_POST["enable_sound"] == "0"){
				$enable_sound = 0;
			}
			$invite_me_cam = 0;
			if($_POST["invite_me_cam"] == "yes"){
				$invite_me_cam=1;	
			}
			$invite_me_rooms = 0;
			if($_POST["invite_me_rooms"] == "yes"){
				$invite_me_rooms=1;	
			}
			$webcam_nopermission = 0;
			if($_POST["webcam_nopermission"] == "yes"){
				$webcam_nopermission=1;	
			}
			$user_options["display_cam"] = $display_cam;
			$user_options["enable_sound"] = $enable_sound;
			$user_options["invite_me_cam"] = $invite_me_cam;
			$user_options["invite_me_rooms"] = $invite_me_rooms;
			$user_options["webcam_nopermission"] = $webcam_nopermission;
			$query = "update ".$this->config->prefix."members_info set visi_chat_set_profile=1, visi_chat_picture='".$this->db->escape_string($pic)."',visi_chat_gender='".$this->db->escape_string(strtolower($_POST["gender"]))."',";
			$query .= "visi_chat_year_of_birth=".$this->db->escape_string($year).",visi_chat_allow_private=".$allow_private.",visi_chat_who_view_mycam=$who_view_mycam,visi_chat_country='".$this->db->escape_string($_POST["country"])."',visi_chat_state='".$this->db->escape_string($_POST["state"])."',visi_chat_city='".$this->db->escape_string($_POST["city"])."',";
			$query .= "visi_chat_marital_status='".$this->db->escape_string($_POST["marital"])."',visi_chat_about='".$this->db->escape_string($_POST["about"])."',visi_chat_user_options='".$this->db->escape_string(base64_encode(serialize($user_options)))."'";
			$query .= " where visi_chat_user_id=".$this->userid;
			$this->db->run_query($query);
			$this->updateIntegrateProfile($year,strtolower($_POST["gender"]));
		}
		$this->db->free_result($res);
	}
	
	function getHost(){
			if(!$this->is_moderator){
				return;
			}
			$ip = $_POST["ip"];
			echo "&host=".urlencode(@gethostbyaddr($ip));
			echo "&result=done";
	}
	function banHost(){
			if(!$this->is_moderator){
				return;
			}
			$ip = $_POST["ip"];
			$hostname = @gethostbyaddr($ip);
			if($hostname == ""){
				echo "&banresult=invalid";
			}else{
				$res = $this->db->run_query("select * from ".$this->config->prefix."banip where ip='".$this->db->escape_string($hostname)."' and bantype=2");
				if($this->db->get_num_rows($res)>0){
					echo "&banresult=already";
				}else{
					if($ip != $hostname){
						$this->db->run_query("insert into "	.$this->config->prefix."banip (ip,bantype) values('".$this->db->escape_string($hostname)."',2)");
						echo "&banresult=done";
					}else{
						echo "&banresult=same";
					}
				}
				$db->free_result($res);
			}
			echo "&result=done";
	}	
	function saveColor(){
		// User options
		$res = $this->db->run_query("select * from ".$this->members_table." inner join ".$this->config->prefix."members_info on ".$this->members_table.".".$this->id_field."=".$this->config->prefix."members_info.visi_chat_user_id where ".$this->id_field."=".$this->userid);
		if($this->db->get_num_rows($res)>0){
			$row = $this->db->fetch_assoc($res);
			$user_options = unserialize(base64_decode($row["visi_chat_user_options"]));
			$user_options["color"] = $_POST["color"];
			$query = "update ".$this->config->prefix."members_info set visi_chat_user_options='".$this->db->escape_string(base64_encode(serialize($user_options)))."'";
			$query .= " where visi_chat_user_id=".$this->userid;
			$this->db->run_query($query);
		}
		$this->db->free_result($res);
	}	
	function vote(){
		$vote = $_POST["vote"];
		$user = $_POST["sender"];
		if(!is_numeric($vote) || $vote == "" || $vote<0 || $vote>5){
			return;
		}
		$res = $this->db->run_query("select * from ".$this->config->prefix."votes where username='".$this->db->escape_string($this->username)."' and friendname='".$this->db->escape_string($user)."'");
		if($this->db->get_num_rows($res)>0){
			$this->db->run_query("update ".$this->config->prefix."votes set vote_value=".$this->db->escape_string($vote)." where username='".$this->db->escape_string($this->username)."' and friendname='".$this->db->escape_string($user)."'");
		}else{
			$this->db->run_query("insert into ".$this->config->prefix."votes (username,friendname,vote_value) values('".$this->db->escape_string($this->username)."','".$this->db->escape_string($user)."',".$this->db->escape_string($vote).")");
		}
		$this->db->free_result($res);
		$res = $this->db->run_query("select count(id) as cnt, avg(vote_value) as rate from ".$this->config->prefix."votes where friendname='".$this->db->escape_string($user)."'");
		$row = $this->db->fetch_assoc($res);
		$this->db->run_query("update ".$this->config->prefix."members_info set visi_chat_votes=".$this->db->escape_string($row["cnt"]).", visi_chat_rate=".$row["rate"]." where visi_chat_user_id=".$this->db->escape_string($this->getIdByUsername($user)));
		echo "&voteCnt=".$row["cnt"]."&voteRate=".$row["rate"];
		$this->db->free_result($res);
	}
	function block(){
		$user = $_POST["sender"];
		if($user == ""){
			return;
		}
		
		if($this->isModerator($user)){
			echo "&result=moderator";
			return;
		}
		
		$res = $this->db->run_query("select * from ".$this->config->prefix."block_list where username='".$this->db->escape_string($this->username)."' and blockname='".$this->db->escape_string($user)."'");
		if($this->db->get_num_rows($res)==0){
			$this->db->run_query("insert into ".$this->config->prefix."block_list (username,blockname) values('".$this->db->escape_string($this->username)."','".$this->db->escape_string($user)."')");
			echo "&result=success";
		}else{
			echo "&result=already";
		}
		$this->db->free_result($res);
	}
	function unblock(){
		$user = $_POST["sender"];
		$this->db->run_query("delete from ".$this->config->prefix."block_list where username='".$this->db->escape_string($this->username)."' and blockname='".$this->db->escape_string($user)."'");
	}
	function addbuddy(){
		$user = $_POST["sender"];
		$res = $this->db->run_query("select * from ".$this->config->prefix."friend_list where username='".$this->db->escape_string($this->username)."' and friendname='".$this->db->escape_string($user)."'");
		if($this->db->get_num_rows($res)==0){
			$this->db->run_query("insert into ".$this->config->prefix."friend_list (username,friendname,approved) values('".$this->db->escape_string($this->username)."','".$this->db->escape_string($user)."',0)");
		}
		$this->db->free_result($res);
	}
	function delbuddy(){
		$user = $_POST["sender"];
		$res = $this->db->run_query("delete from ".$this->config->prefix."friend_list where username='".$this->db->escape_string($this->username)."' and friendname='".$this->db->escape_string($user)."'");
	}	
	function acceptbuddy(){
		$user = $_POST["sender"];
		$this->db->run_query("update ".$this->config->prefix."friend_list set approved=1 where username='".$this->db->escape_string($user)."' and friendname='".$this->db->escape_string($this->username)."'");
	}
	function rejectbuddy(){
		$user = $_POST["sender"];
		$this->db->run_query("delete from ".$this->config->prefix."friend_list where username='".$this->db->escape_string($user)."' and friendname='".$this->db->escape_string($this->username)."'");
	}
	function offlineMsg(){
		$to = $_POST["to"];
		$msg = $_POST["text"];
		if($msg != "" && $to != ""){
			$this->db->run_query("insert into ".$this->config->prefix."offline_messages (m_from,m_to,m_time,m_message) values('".$this->db->escape_string($this->username)."','".$this->db->escape_string($to)."',".time().",'".$this->db->escape_string($msg)."')");
		}
	}
	function createRoom(){
		if(!$this->getPermission("create_room")){
			echo "&result=noaccess";
		}
		$roomName = $_POST["roomName"];
		$roomKey = $_POST["roomKey"];
		$adult = "0";
		if($_POST["adult"]=="yes" && $this->adult){
			$adult ="1";
		}
		$allow = false;
		if($this->setting->get("enable_user_created_rooms") == "no"){
			echo "&result=disabled";
		}else{
			if(!$this->is_moderator){
				if($this->setting->get("member_create_room") == "no"){
					echo "&result=noaccess";
				}else{
					$allow = true;
				}
			}else{
				$allow = true;
			}
		}
		// Check if room is already exists
		if($allow){
			$res = $this->db->run_query("select * from ".$this->config->prefix."rooms where room_name='".$this->db->escape_string($roomName)."'");
			if($this->db->get_num_rows($res) >0){
				echo "&result=already_exists";
				$allow =false;
			}
			$this->db->free_result($res);
		}
		// Check if user already created a private room
		if($allow){
			$res = $this->db->run_query("select * from ".$this->config->prefix."rooms where room_creator=".$this->db->escape_string($this->userid));
			if($this->db->get_num_rows($res) >0){
				echo "&result=already";
				$allow =false;
			}
			$this->db->free_result($res);
		
			// Check maximum number of user created rooms
			if(is_numeric($this->setting->get("user_created_room_limit")) &&  $this->setting->get("user_created_room_limit")>0)
			{
				$res = $this->db->run_query("select count(room_id) as cid from ".$this->config->prefix."rooms where room_type='u'");
				$row = $this->db->fetch_assoc($res);
				if($row["cid"] >= $this->setting->get("user_created_room_limit")){
					echo "&result=max";
					$allow =false;
				}
				$this->db->free_result($res);
			}
		}
		
		$capacity = 0;
		if(is_numeric($this->setting->get("user_created_room_capacity")) &&  $this->setting->get("user_created_room_capacity")>0)
		{
			$capacity =  $this->setting->get("user_created_room_capacity");
		}
		// If has access to create rooms
		if($allow){
			$this->db->run_query("insert into ".$this->config->prefix."rooms (room_name,room_capacity,room_key,room_type,room_public,room_creator,room_adult) values('".$this->db->escape_string($roomName)."',".$this->db->escape_string($capacity).",'".$this->db->escape_string($roomKey)."','u',1,".$this->db->escape_string($this->userid).",$adult)");
			// get room id
			$res = $this->db->run_query("select * from ".$this->config->prefix."rooms where room_name='".$this->db->escape_string($roomName)."'");
			if($this->db->get_num_rows($res) >0){
				$row = $this->db->fetch_assoc($res);
				echo "&roomID=".$row["room_id"];
				echo "&result=success";
			}else{
				echo "&result=failed";
			}
			$this->db->free_result($res);
		}
	}
	// vote games
	function voteGame(){
		if($_POST["game"]== "" || $_POST["vote"] == "" || !is_numeric($_POST["game"]) || !is_numeric($_POST["vote"])){
			return;
		}
		$gameid = $_POST["game"];
		$vote = $_POST["vote"];
		if($vote<1){$vote = 1;}
		if($vote>5){$vote = 5;}
		$vote = $vote*10000;
		$res = $this->db->run_query("select * from ".$this->config->prefix."games where id=".$this->db->escape_string($gameid));
		if($this->db->get_num_rows($res)>0){
			$row = $this->db->fetch_assoc($res);
			$votes = $row["g_votes"];
			$new_rate = (($row["g_rate"]*$votes) + $vote)/($votes+1);
			$this->db->run_query("update ".$this->config->prefix."games set g_rate=".$new_rate.", g_votes=g_votes+1 where id=".$this->db->escape_string($gameid));
			echo "&newVotes=".($votes+1);
			echo "&newRate=".($new_rate/10000);			
		}
		$this->db->free_result($res);
		echo "&result=saved";
	}
	// Returns current active payment gateways
	function loadGateways(){
		 $res  = $this->db->run_query("select * from ".$this->config->prefix."gateways where g_active=1 order by g_order desc");
		 $payment = $this->factory->getInstance("payment");
		 echo "&payment_cnt=".$this->db->get_num_rows($res);
		 for($i=0;$i<$this->db->get_num_rows($res);$i++){
		 	$row = $this->db->fetch_assoc($res,$i);
			echo "&payment_id_".$i."=".urlencode($row["id"]);
			echo "&payment_name_".$i."=".urlencode($row["g_name"]);
			echo "&payment_title_".$i."=".urlencode($row["g_title"]);
			echo "&payment_credit_".$i."=".urlencode($row["g_credit"]);
			$gateway = $payment->getOptions($row["id"]);
			echo "&payment_price_".$i."=".urlencode($gateway["price"]);
		 }
		 $this->db->free_result($res);
	}
	// Returns country name based on the given ip address
	function getCountry(){
		if(!$this->is_moderator){
			return;
		}
		$ip = $_POST["ip"];
		$ipdata = split('\.',$ip);
		if(count($ipdata)==4){
			if(is_numeric($ipdata[0]) && is_numeric($ipdata[1]) && is_numeric($ipdata[2]) && is_numeric($ipdata[3])){
				$ipvalue = ($ipdata[0]*256*256*256) + ($ipdata[1]*256*256) + ($ipdata[2]*256) + $ipdata[3];
				$res = $this->db->run_query("select * from ".$this->config->prefix."ip2country where i_from<".$ipvalue." and i_to>".$ipvalue);
				if($this->db->get_num_rows($res)>0){
					$row = $this->db->fetch_assoc($res);
					echo "&country_code=".$row["i_code"];
					echo "&country_name=".$row["i_name"];
				}
				$this->db->free_result($res);
			}
		}
	}
	// Get permission
	function getPermission($feature){
		if($this->setting->get("perm_".$this->user_type."_".$feature)=="yes"){
			return true;
		}
		return false;
	}

   function upload_remote_pic(){
   		// limit 1 MB
        $limit = 512*1024;
		$url = $_POST["url"];
		
		// Checking File size step 1
		$remoteSize = $this->getRemoteFileSize($url);
		echo "&ss=".$remoteSize;
		if( $remoteSize > $limit){
			echo "&result=bigfile";
			return;
		}
		if($remoteSize == 0){
			echo "&result=notfound";
			return;
		}
		
		// Checking file size step 2
		if ($fp = fopen($url, 'r')) {
   			$content = '';
			$counter =0;
		    while ($line = fread($fp, 2048)) {
				$counter ++;
				if($counter>256){
					echo "&result=bigfile";
					fclose($fp);
					return;
				}
   			}
		} else {
			echo "&result=notfound";
			fclose($fp);
			return;
		}
		fclose($fp);
		
		// get image size and other info
   		$imagesize = GetImageSize ($url);
		
		// Abort if invalid picture
		if(!is_array($imagesize)){
			echo "&result=notfound";
			return;
		}
 		// Validating by mime type
 		$ext = "";		
		if($imagesize["mime"] == "image/gif"){
			$ext = "gif";
		}
		if($imagesize["mime"] == "image/jpeg"){
			$ext = "jpg";
		}
		if($imagesize["mime"] == "image/png"){
			$ext = "png";
		}
		if($imagesize[0] == 0 || $ext == ""){
		   echo "&result=notfound";
		   return;
		}

		// Copy picture to the host into a temporary filename
		$uploadPath = LIB_PATH.DS."..".DS."..".DS."members".DS;
		$fileName 	= $this->userid."-p-".md5(rand(200000,9999999999)).md5(rand(200000,9999999999)).".file";
		$picName 	= $this->userid."-p-".md5(rand(200000,9999999999)).md5(rand(200000,9999999999)).".jpg";
		copy($url, $uploadPath.$fileName);
		
		// Get file size
		$size = filesize( $uploadPath.$fileName);
		
		if($size> 0){
			if($size < $limit){
				$picWidth = $imagesize[0];
				if($picWidth>800){
					$picWidth = 800;
				}
				$this->resize($uploadPath.$fileName, $uploadPath.$picName, $picWidth,$ext);
				$this->resize($uploadPath.$fileName, $uploadPath."thumbnails".DS.$picName, 400,$ext);
				echo "&picname=".urlencode($picName);
				echo "&result=success";
			}else{
				echo "&result=bigfile";
			}
		}else{
			echo "&result=notfound";   
		}
		
		// Remove temporary file
		unlink($uploadPath.$fileName);

   }
   
   function getRemoteFileSize($url){
	   $parsed = parse_url($url);
	   $host = $parsed["host"];
	   $fp = @fsockopen($host, 80, $errno, $errstr, 20);
	   if(!$fp)return false;
	   else {
		   @fputs($fp, "HEAD $url HTTP/1.1\r\n");
		   @fputs($fp, "HOST: $host\r\n");
		   @fputs($fp, "Connection: close\r\n\r\n");
		   $headers = "";
		   while(!@feof($fp))$headers .= @fgets ($fp, 128);
	   }
	   @fclose ($fp);
	   $return = 0;
	   $arr_headers = explode("\n", $headers);
	   foreach($arr_headers as $header) {
		   $s = "Content-Length: ";
		   if(substr(strtolower ($header), 0, strlen($s)) == strtolower($s)) {
			   $return = trim(substr($header, strlen($s)));
			   break;
		   }
	   }
	   return $return;
	}

   
   function report_user(){
    	$badUser = $_POST["badUser"];
		$complain = $_POST["complain"];
		if($badUser == ""){
			return;
		}
		$res = $this->db->run_query("select * from ".$this->config->prefix."reports where r_type=3 and username ='".$this->db->escape_string($this->username)."' and r_var='".$this->db->escape_string($badUser)."'");
		if($this->db->get_num_rows($res)==0){
			$this->db->run_query("insert into ".$this->config->prefix."reports (r_type,username,r_ip,r_date,r_var,description) values(3,'".$this->db->escape_string($this->username)."','".$this->db->escape_string($_SERVER['REMOTE_ADDR'])."',".time().",'".$this->db->escape_string($badUser)."','".$this->db->escape_string($complain)."')");
			echo "&result=success";
		}else{
			echo "&result=already";
		}
		$this->db->free_result($res);
   }
   function forgotPass(){
   		$email = $_POST["email"];
		if($email == ""){
			return;
		}
		if($this->setting->get("integrate") <> ""){
			return "";
		}
		$res = $this->db->run_query("select * from ".$this->setting->get("members_table")." where ".$this->setting->get("email_field")."='".$this->db->escape_string($email)."'");
		if($this->db->get_num_rows($res)==0){
			echo "&result=notfound";		
		}else{
			$row = $this->db->fetch_assoc($res);
			
			// Check if today recover password email is already sent to the user
			$check = $this->db->run_query("select * from ".$this->config->prefix."password_recovery where user_id=".$this->db->escape_string($row[$this->id_field])." order by r_date desc");
			if($this->db->get_num_rows($check)>0){
				$checkrow = $this->db->fetch_assoc($check);
				if(date("F j, Y") == date("F j, Y",$checkrow["r_date"])){
					echo "&result=already";
					$this->db->free_result($check);
					$this->db->free_result($res);
					return;
				}
			}
			$this->db->free_result($check);
			
			// Creating email body
			$language = $this->factory->getInstance("language");
			$language->language = str_replace(array("\\","/","..",".","?","*","|",":"),"",$_POST["ln"]);
			$language->load();

			$key1 = md5(md5(rand("1111111111","999999999999")).rand("1111111111","999999999999"));
			$key2 = md5(md5(rand("1111111111","999999999999")).rand("1111111111","999999999999"));
			
			$key = md5($key1.$key2);
			
			//$link = substr($_SERVER["PHP_SELF"],0,strlen($_SERVER["PHP_SELF"])-14);
			//$link = "http://".$_SERVER["HTTP_HOST"].$link."/recover.php?u=".$row[$this->id_field]."&key=".$key;

			$subject = $language->get("forgot_password_subject");
			$body = $language->get("forgot_password_text1",$row[$this->username_field]);
			$body .= "<br><br>".$language->get("forgot_password_text2");
			$body .= "<br><br>".$language->get("forgot_password_text3");
			$body .= "<br><br><b>Username:</b> ".$row[$this->username_field];
			$body .= "<br><b>Request Code:</b> ".$key;
			$body .= "<br><br>".$language->get("forgot_password_text4");
			$body .= "<br><br>".$language->get("forgot_password_text5");
			$body .= "<br>".$this->setting->get("website_title");
			// Send password reset instructions
			if($this->factory->sendEmail($email,$subject,$body)){
				echo "&result=sent";
				// Delete old requests from this user from DB and also requests which are older than 2 days
				$this->db->run_query("delete from ".$this->config->prefix."password_recovery where user_id=".$this->db->escape_string($row[$this->id_field])." or r_date<".(time()-(48*3600)));
				$this->db->run_query("insert into ".$this->config->prefix."password_recovery(user_id,r_date,ip,keycode) values(".$this->db->escape_string($row[$this->id_field]).",".time().",'".$this->db->escape_string($_SERVER['REMOTE_ADDR'])."','".$this->db->escape_string($key)."')");
			}else{
				echo "&result=failed";
			}
		}
		$this->db->free_result($res);
   }
   function changePassword(){
   		if($_POST["resetUsername"] == "" || $_POST["resetKey"] == "" || $_POST["newPassword"]==""){
			return;
		}
		// check username
		$res = $this->db->run_query("select * from ".$this->members_table." where ".$this->username_field."='".$this->db->escape_string($_POST["resetUsername"])."'");
		if($this->db->get_num_rows($res)==0){
			$this->db->free_result($res);
			echo "&result=notfound";
			return;
		}
		$row = $this->db->fetch_assoc($res);
		$this->db->free_result($res);
		
		// check code
		$res = $this->db->run_query("select * from ".$this->config->prefix."password_recovery where user_id=".$this->db->escape_string($row[$this->id_field])." and keycode='".$this->db->escape_string($_POST["resetKey"])."'");

		if($this->db->get_num_rows($res)==0){
			$this->db->free_result($res);
			echo "&result=notfound";
			return;
		}
		$row = $this->db->fetch_assoc($res);
		$this->db->free_result($res);
		// change password
		$this->db->run_query("update ".$this->members_table." set ".$this->password_field."='".$this->db->escape_string(md5($_POST["newPassword"]))."' where ".$this->username_field."='".$this->db->escape_string($_POST["resetUsername"])."'");
		
		// Delete request
		$this->db->run_query("delete from ".$this->config->prefix."password_recovery where user_id=".$this->db->escape_string($row["user_id"])." or r_date<".(time()-(48*3600)));
		echo "&result=done";
		
   }
	// Clean logs and old pictures
	function cleanUp(){
		if($this->setting->get("log_days")>0 && $this->setting->get("log_days") != 0){
			$this->db->run_query("delete from ".$this->config->prefix."log_history where l_date<".(time()-($this->setting->get("log_days")*86400)));
		}
		$this->db->run_query("delete from ".$this->config->prefix."reports where r_date<".(time()-30*86400));
	}
	function cleanupPics(){
		$yesterday = time()- 86400;
		$pics = $this->db->run_query("select * from ".$this->setting->get("temp_pictures_table")." where p_time<".$yesterday." and p_type='p'");
		for($i=0;$i<$this->db->get_num_rows($pics);$i++){
			$picrow = $this->db->fetch_assoc($pics,$i);
			$filepath = "../members/".$picrow["picname"];
			if(is_file($filepath)){
				unlink($filepath);
			}
			$filepath = "../members/thumbnails/".$picrow["picname"];
			if(is_file($filepath)){
				unlink($filepath);
			}
		}
		$this->db->free_result($pics);
		$this->db->run_query("delete from ".$this->setting->get("temp_pictures_table")." where p_time<".$yesterday);
	}
	function isModerator($username){
		$id = $this->getIdByUsername($username);
		if($id == "" || !is_numeric($id)){
			return;
		}
		$res = $this->db->run_query("select * from ".$this->config->prefix."members_info where visi_chat_user_id=".$this->db->escape_string($id));
		if($this->db->get_num_rows($res)>0){
			$row = $this->db->fetch_assoc($res);
			$this->db->free_result($res);
			if($row["visi_chat_is_mod"] == 3 || $row["visi_chat_is_mod"] == 1){
				return true;
			}
		}
		$this->db->free_result($res);
		return false;
	}
	function getIdByUsername($username){
		$id = 0;
		$res = $this->db->run_query("select * from ".$this->members_table." where ".$this->username_field."='".$this->db->escape_string($username)."'");
		if($this->db->get_num_rows($res)>0){
			$row = $this->db->fetch_assoc($res);
			$id = $row[$this->id_field];
		}
		$this->db->free_result($res);
		return $id;
	}
	function check_updates(){
		$allow_check = true;
		$res = $this->db->run_query("select * from ".$this->config->prefix."setting where set_property='update_check_date'");
		$update_check_date =0;
		
		if($this->db->get_num_rows($res) > 0){
		   $row = $this->db->fetch_assoc($res);
		   $update_check_date = $row["set_value"];
		}
		$this->db->free_result($res);
		
		if($update_check_date ==0){
			$this->db->run_query("update ".$this->config->prefix."setting set set_value='".time()."' where set_property='update_check_date'");
			$allow_check = true;
		}
		if(floor($update_check_date/86400) < floor(time()/86400)){
			$this->db->run_query("update ".$this->config->prefix."setting set set_value='".time()."' where set_property='update_check_date'");
			$allow_check = true;
		}
		if($allow_check){
			$update_url = "/autoupdate.php?v=".$this->setting->get("version")."&key=".$this->setting->get("key");
			$fp = fsockopen("www.gchats.com", 80, $errno, $errstr);
			if (!$fp) {
			} else {
				$out = "GET $update_url HTTP/1.1\r\n";
				$out .= "Host: www.gchats.com\r\n";
				$out .= "Connection: Close\r\n\r\n";
				fwrite($fp, $out);
				$contents = '';
				while (!feof($fp)) {
					$contents .= fgets($fp, 128);
				}
				fclose($fp);
				$s = strpos($contents,"<font color='#");
				if($s===FALSE){
					$contents = "&nbsp;";
				}else{
					$contents = substr($contents,$s);
				}
				
				$this->db->run_query("delete from ".$this->config->prefix."setting where set_property='update_contents_field'");
				
				$this->db->run_query("insert into ".$this->config->prefix."setting (set_property,set_value) values('update_contents_field','".$this->db->escape_string($contents)."')");

			}
		}
	}
	function delete_inactive(){
		if($this->setting->get("email_activation")=="yes" && $this->setting->get("delete_non_activated")=="yes"){
			$res = $this->db->run_query("select * from ".$this->setting->get("members_info_table")." where visi_chat_email_verified=0 and visi_chat_signup_time>0 and visi_chat_signup_time<".(time()-(3600*48)));
			for($i=0;$i<$this->db->get_num_rows($res);$i++){
				$row = $this->db->fetch_assoc($res,$i);
				$this->db->run_query("delete from ".$this->setting->get("members_table")." where id=".$row["visi_chat_user_id"]);
				$this->db->run_query("delete from ".$this->setting->get("members_info_table")." where visi_chat_user_id=".$row["visi_chat_user_id"]);
			}
			$this->db->free_result($res);
		}
	}
	function updateIntegrateProfile($year,$gender){
		switch($this->setting->get("integrate")){
			case 'SocialEngine':
				$birthday_field = 'profilevalue_4'; // Change if required
				$gender_field = 'profilevalue_5'; // Change if required
				if($gender != "c" && $gender != "m" && $gender != "f"){$gender ="m";}
				if($gender == "m"){$gender = "1";}
				if($gender == "f"){$gender = "2";}
				if($gender == "c"){$gender = "3";}
				$res = $this->db->run_query("select year($birthday_field) as year from se_profilevalues where profilevalue_user_id=".$this->userid);
				$row = $this->db->fetch_assoc($res);
				$this->db->free_result($res);
				$year_diff = $year- $row["year"];
				$this->db->run_query("update se_profilevalues set $birthday_field=ADDDATE($birthday_field, Interval $year_diff YEAR),$gender_field='".$this->db->escape_string($gender)."' where profilevalue_user_id=".$this->userid);
			break;
		}
	}
	function resize($filein, $fileout, $newwidth,$ext){
		list($width, $height) = getimagesize($filein);
		if($width>$height){
		   $newwidth = $newwidth;
		   $newheight=$height*$newwidth/$width; 
		}else{
		$newheight = $newwidth;
		 $newwidth=$width*$newheight/$height;    
		}
		if($ext=="jpg"){
			$thumb = @imagecreatetruecolor($newwidth,$newheight);
		   $source = @imagecreatefromjpeg("$filein");
		}	   
		if($ext=="gif"){
			$thumb = @imagecreate($newwidth,$newheight);		
		   $source = @imagecreatefromgif("$filein");
		}
		if($ext=="png"){
			$thumb = @imagecreatetruecolor($newwidth,$newheight);		
		   $source = @imagecreatefrompng("$filein");
		}
		if($source ){		
			$background_cl = imagecolorallocate($thumb,255,255,255);		
			imagecopyresized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
			imagejpeg($thumb, $fileout,90);
			return true;
		}
		return false;
	}
	function close_db(){
		$this->db->close();
	}
}



?>