<?php
/****************************************************************************\|
| Gchats Visichat		                                               		  |
| Copyright (c) 2007-2012 Gchats http://www.gchats.com      				  |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT"  |
| FILE PROVIDED WITH THIS DISTRIBUTION.                                       |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| GCHATS Visichat 2.0 PROGRAM WITH  THIS  AGREEMENT.                          |
| PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS  LICENSE AGREEMENT |
| CAREFULLY   BEFORE   INSTALLING   OR  USING  THE  SOFTWARE.  BY INSTALLING, |
| COPYING   OR   OTHERWISE   USING   THE   SOFTWARE,  YOU  AND  YOUR  COMPANY |
| (COLLECTIVELY,  "YOU")  ARE  ACCEPTING  AND AGREEING  TO  THE TERMS OF THIS |
| LICENSE   AGREEMENT.   IF  YOU    ARE  NOT  WILLING   TO  BE  BOUND BY THIS |
| AGREEMENT, DO  NOT INSTALL OR USE THE SOFTWARE.  VARIOUS   COPYRIGHTS   AND |
| OTHER   INTELLECTUAL   PROPERTY   RIGHTS    PROTECT   THE   SOFTWARE.  THIS |
| AGREEMENT IS A LICENSE AGREEMENT THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE |
| THE  SOFTWARE   AND  NOT  AN  AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE.|
| THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY GRANTED BY THIS AGREEMENT.      |
|                                                                             |
| The Initial Developer of the Original Code is Gchats.com			          |
\*****************************************************************************/
session_start();
include_once("../library/nocache.php");
include_once("../library/factory.php");
$factory 	= new factory();
$db 		= $factory->get_db();
$setting 	= $factory->getInstance("GSetting");
$config = $factory->getInstance("config");
$payment = $factory->getInstance("payment");
$members_table = $setting->get("members_table");
$members_info_table = $setting->get("members_info_table");
$id_field = $setting->get("id_field");
$gateways_table = $config->prefix."gateways";
$scripts_url = "http://".$_SERVER["HTTP_HOST"].substr($_SERVER["PHP_SELF"],0,strlen($_SERVER["PHP_SELF"])-19)."/";


// Getting payment method
$method = 0;
if(isset($_GET["g"])){
	if(is_numeric($_GET["g"]) && $_GET["g"] != "" && $_GET["g"]>0){
		$method = $_GET["g"];
	}
}

// Get Referral id
$referral = 0;
if(isset($_GET["referral"])){
	if(is_numeric($_GET["referral"]) && $_GET["referral"] != "" && $_GET["referral"]>0){
		$res = $db->run_query("select * from ".$members_table." where ".$id_field."=".$db->escape_string($_GET["referral"]));
		if($db->get_num_rows($res) >0){
			$referral = $_GET["referral"];	
		}
	}
}
// Checking payment method
if(!$payment->isActive($method)){
	die("An error occurred. Please try again...");
}
// getting payment details
$res = $db->run_query("select * from ".$gateways_table." where id=".$db->escape_string($method));
$row = $db->fetch_assoc($res);
$db->free_result($res);

// Double checking payment method
if(!$payment->isValid($row["g_name"])){
	die("An error occurred. Please try again...");
}
$gateway = $row["g_name"];
$credits = $row["g_credit"];
$options = $payment->getOptions($method);
$details = $payment->get($gateway);
$userid = $_REQUEST[$details[2][0][1]];
if($userid == ""){
	$userid = 0;
}
if($gateway == "targetpay"){
	$userid=$_SESSION["targetpay_userid"];
}

$error_url = $scripts_url."payment/result.php?res=error&g=".$method."&id=".$userid;
// Validating user id
$res = $db->run_query("select * from ".$members_table." where ".$id_field."=".$db->escape_string($userid));
if($db->get_num_rows($res)==0){
	die("An error occurred. Please try again...");
}
$db->free_result($res);

// Validating payment
$transaction_valid = false;
$ticket = "";


switch($gateway){
	case 'allopass-sms':
		$ticket = urlencode($_GET["RECALL"]);
		// Avoid adding credits if user refresh		
		$res = $db->run_query("select * from ".$config->prefix."transactions where tra_sender_id=".$db->escape_string($userid)." and tra_type ='allopass' and tra_date> ".(time()-86400)." and tra_ticket='".$db->escape_string($ticket)."'");
		if($db->get_num_rows($res)>0){
			$transaction_valid = false;
		}else{		
			@file("http://www.allopass.com/check/index.php4?CODE=".$_GET["RECALL"]."&SITE_ID=".$options["site_id"]."&DOC_ID=".$options["doc_id"]);
			$r=@file("http://www.allopass.com/check/vf.php4?CODE=".$_GET["RECALL"]."&AUTH=".$options["id_code"]);
			if (ereg("ERR",$r[0]) || ereg("NOK",$r[0])) {
				$transaction_valid = false;
			}else{
				$transaction_valid = true;
			}
		}
		$db->free_result($res);
	break;
	case 'allopass-cc':
		$ticket = urlencode($_GET["RECALL"]);
		$AUTH = urlencode($options["id_code"]);
		// Avoid adding credits if user refresh		
		$res = $db->run_query("select * from ".$config->prefix."transactions where tra_sender_id=".$db->escape_string($userid)." and tra_type ='allopass' and tra_date> ".(time()-86400)." and tra_ticket='".$db->escape_string($ticket)."'");
		if($db->get_num_rows($res)>0){
			$transaction_valid = false;
		}else{
 			$r=@file("http://payment.allopass.com/api/checkcode.apu?code=$ticket&auth=$AUTH");
			if (ereg("ERR",$r[0]) || ereg("NOK",$r[0]))
			{
				$transaction_valid = false;
			}else{
				$transaction_valid = true;
			}
		}
		$db->free_result($res);		
	break;	
	case 'usaepay':
		$req = 'codes';
		foreach ($_GET as $key => $value) {
			$value = urlencode(stripslashes($value));
			$req .= "&$key=$value\r\n";
		}
		$req.= "ip: ".$_SERVER['REMOTE_ADDR'];
		include("usaepay/check.php");
		$transaction_valid = checkUSAEPAY();
	break;
	case 'paypal':
		include("paypal/check.php");
		$ticket = $_POST['payer_email'];
		$transaction_valid = checkPaypal();
	break;
	case 'alertpay':
		$ticket = $_POST['ap_custemailaddress'];
		$transaction_valid = false;
		if($_POST["ap_securitycode"] == $options["security_code"] && $_POST["ap_status"]=="Success" && $_POST['ap_test']!="1"){
			if (strlen($_POST["ap_referencenumber"]) >0 && $_POST['ap_trialamount'] != "0"){
				$transaction_valid = true;	
			}
		}
	break;
	case 'buckaroo':
		$signature = md5($_POST["bpe_trx"].$_POST["bpe_timestamp"].$options["buckaroo_merchant"].$_POST["bpe_invoice"].$_POST["bpe_reference"]."EUR".$options["price"].$_POST["bpe_result"]."0".$options["secret_key"]);
		if($signature == $_POST["bpe_signature2"]){
			$ticket = $_POST["bpe_trx"].$signature;			
			$res = $db->run_query("select * from ".$config->prefix."transactions where tra_sender_id=".$db->escape_string($userid)." and tra_ticket='".$db->escape_string($ticket)."'");
			if($db->get_num_rows($res)==0){			
				$transaction_valid=true;
			}
			$db->free_result($res);
		}
		
	break;
	case 'targetpay':
		include("targetpay/check.php");
		
		if(access($options["hash_code"])){
			$ticket = $_GET["accesscode"]."-".$_SESSION["targetpay_hash"];			
			$res = $db->run_query("select * from ".$config->prefix."transactions where tra_sender_id=".$db->escape_string($userid)." and tra_ticket='".$db->escape_string($ticket)."'");
			if($db->get_num_rows($res)==0){	
				$transaction_valid=true;
			}
			$db->free_result($res);
		}
	break;
}

// If transaction successful
if($transaction_valid){
	$db->run_query("update ".$members_info_table." set visi_chat_credits=visi_chat_credits+".$credits." where visi_chat_user_id=".$db->escape_string($userid));
	$db->run_query("insert into ".$config->prefix."transactions (tra_sender_id,tra_receiver_id,tra_amount,tra_reason,tra_date,tra_type,tra_ticket,tra_referral) values(".$db->escape_string($userid).",0,".$db->escape_string($credits).",3,".time().",'".$db->escape_string($gateway)."','".$db->escape_string($ticket)."',$referral)");
	$db->close();  
?>
<script language="javascript">
	window.alert("Your payment has been credited to your account.");
	window.close();
</script>
<?php
}else{
	echo '<meta http-equiv="refresh" content="0;URL='.$scripts_url."payment/result.php?res=error&payment=".$method."&id=".$userid.'" />';
	$db->close();	
	exit();
}

?>